/**
 * freesewing | v0.31.0
 * A library for creating made-to-measure sewing patterns
 * (c) 2019 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
var freesewing=function(){"use strict";function t(t,e,i){return e in t?Object.defineProperty(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}function e(e){for(var i=1;i<arguments.length;i++){var n=null!=arguments[i]?arguments[i]:{},r=Object.keys(n);"function"==typeof Object.getOwnPropertySymbols&&(r=r.concat(Object.getOwnPropertySymbols(n).filter(function(t){return Object.getOwnPropertyDescriptor(n,t).enumerable}))),r.forEach(function(i){t(e,i,n[i])})}return e}function i(){this.list={}}function n(t,e){this.x=A(t),this.y=A(e),this.attributes=new i}function r(t,e){return t(e={exports:{}},e.exports),e.exports}i.prototype.add=function(t,e){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(e),this},i.prototype.set=function(t,e){return this.list[t]=[e],this},i.prototype.remove=function(t){return delete this.list[t],this},i.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},i.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},i.prototype.render=function(){let t="";for(let e in this.list)t+=` ${e}="${this.list[e].join(" ")}"`;return t},i.prototype.renderAsCss=function(){let t="";for(let e in this.list)t+=` ${e}:${this.list[e].join(" ")};`;return t},i.prototype.renderIfPrefixIs=function(t=""){let e="",i=t.length;for(let n in this.list)n.substr(0,i)===t&&(e+=` ${n.substr(i)}="${this.list[n].join(" ")}"`);return e},i.prototype.clone=function(){let t=new i;return t.list=JSON.parse(JSON.stringify(this.list)),t},n.prototype.rad2deg=function(t){return 57.29577951308232*t},n.prototype.deg2rad=function(t){return t/57.29577951308232},n.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},n.prototype.dist=function(t){let e=this.x-t.x,i=this.y-t.y;return A(Math.sqrt(Math.pow(e,2)+Math.pow(i,2)))},n.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},n.prototype.dx=function(t){return t.x-this.x},n.prototype.dy=function(t){return t.y-this.y},n.prototype.angle=function(t){let e=Math.atan2(-1*this.dy(t),this.dx(t));for(;e<0;)e+=2*Math.PI;return this.rad2deg(e)},n.prototype.rotate=function(t,e){let i=this.dist(e),r=this.angle(e);return new n(e.x+i*Math.cos(this.deg2rad(r+t))*-1,e.y+i*Math.sin(this.deg2rad(r+t)))},n.prototype.copy=function(){return new n(this.x,this.y)},n.prototype.flipX=function(t=!1){return!1===t||0===t.x?new n(-1*this.x,this.y):new n(t.x+this.dx(t),this.y)},n.prototype.flipY=function(t=!1){return!1===t||0===t.y?new n(this.x,-1*this.y):new n(this.x,t.y+this.dy(t))},n.prototype.shift=function(t,e){let i=this.copy();return i.x+=e,i.rotate(t,this)},n.prototype.shiftTowards=function(t,e){return this.shift(this.angle(t),e)},n.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},n.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},n.prototype.shiftFractionTowards=function(t,e){return this.shiftTowards(t,this.dist(t)*e)},n.prototype.shiftOutwards=function(t,e){return this.shiftTowards(t,this.dist(t)+e)},n.prototype.clone=function(){let t=new n(this.x,this.y);return t.attributes=this.attributes.clone(),t},n.prototype.translate=function(t,e){let i=this.copy();return i.x+=t,i.y+=e,i};var s=r(function(t){var e,i,n,r,s,o,h,p,u,a,l,c,y,x,d;e=Math.abs,i=Math.cos,n=Math.sin,r=Math.acos,s=Math.atan2,o=Math.sqrt,h=Math.pow,p=function(t){return t<0?-h(-t,1/3):h(t,1/3)},u=Math.PI,a=2*u,l=u/2,c=Number.MAX_SAFE_INTEGER||9007199254740991,y=Number.MIN_SAFE_INTEGER||-9007199254740991,x={x:0,y:0,z:0},d={Tvalues:[-.06405689286260563,.06405689286260563,-.1911188674736163,.1911188674736163,-.3150426796961634,.3150426796961634,-.4337935076260451,.4337935076260451,-.5454214713888396,.5454214713888396,-.6480936519369755,.6480936519369755,-.7401241915785544,.7401241915785544,-.820001985973903,.820001985973903,-.8864155270044011,.8864155270044011,-.9382745520027328,.9382745520027328,-.9747285559713095,.9747285559713095,-.9951872199970213,.9951872199970213],Cvalues:[.12793819534675216,.12793819534675216,.1258374563468283,.1258374563468283,.12167047292780339,.12167047292780339,.1155056680537256,.1155056680537256,.10744427011596563,.10744427011596563,.09761865210411388,.09761865210411388,.08619016153195327,.08619016153195327,.0733464814110803,.0733464814110803,.05929858491543678,.05929858491543678,.04427743881741981,.04427743881741981,.028531388628933663,.028531388628933663,.0123412297999872,.0123412297999872],arcfn:function(t,e){var i=e(t),n=i.x*i.x+i.y*i.y;return void 0!==i.z&&(n+=i.z*i.z),o(n)},compute:function(t,e,i){if(0===t)return e[0];var n=e.length-1;if(1===t)return e[n];var r=e,s=1-t;if(0===n)return e[0];if(1===n)return l={x:s*r[0].x+t*r[1].x,y:s*r[0].y+t*r[1].y},i&&(l.z=s*r[0].z+t*r[1].z),l;if(n<4){var o,h,p,u=s*s,a=t*t,f=0;2===n?(r=[r[0],r[1],r[2],x],o=u,h=s*t*2,p=a):3===n&&(o=u*s,h=u*t*3,p=s*a*3,f=t*a);var l={x:o*r[0].x+h*r[1].x+p*r[2].x+f*r[3].x,y:o*r[0].y+h*r[1].y+p*r[2].y+f*r[3].y};return i&&(l.z=o*r[0].z+h*r[1].z+p*r[2].z+f*r[3].z),l}for(var c=JSON.parse(JSON.stringify(e));c.length>1;){for(var y=0;y<c.length-1;y++)c[y]={x:c[y].x+(c[y+1].x-c[y].x)*t,y:c[y].y+(c[y+1].y-c[y].y)*t},void 0!==c[y].z&&(c[y]=c[y].z+(c[y+1].z-c[y].z)*t);c.splice(c.length-1,1)}return c[0]},derive:function(t,e){for(var i=[],n=t,r=n.length,s=r-1;r>1;r--,s--){for(var o,h=[],p=0;p<s;p++)o={x:s*(n[p+1].x-n[p].x),y:s*(n[p+1].y-n[p].y)},e&&(o.z=s*(n[p+1].z-n[p].z)),h.push(o);i.push(h),n=h}return i},between:function(t,e,i){return e<=t&&t<=i||d.approximately(t,e)||d.approximately(t,i)},approximately:function(t,i,n){return e(t-i)<=(n||1e-6)},length:function(t){var e,i,n=0,r=d.Tvalues.length;for(e=0;e<r;e++)i=.5*d.Tvalues[e]+.5,n+=d.Cvalues[e]*d.arcfn(i,t);return.5*n},map:function(t,e,i,n,r){return n+(r-n)*((t-e)/(i-e))},lerp:function(t,e,i){var n={x:e.x+t*(i.x-e.x),y:e.y+t*(i.y-e.y)};return e.z&&i.z&&(n.z=e.z+t*(i.z-e.z)),n},pointToString:function(t){var e=t.x+"/"+t.y;return void 0!==t.z&&(e+="/"+t.z),e},pointsToString:function(t){return"["+t.map(d.pointToString).join(", ")+"]"},copy:function(t){return JSON.parse(JSON.stringify(t))},angle:function(t,e,i){var n=e.x-t.x,r=e.y-t.y,o=i.x-t.x,h=i.y-t.y;return s(n*h-r*o,n*o+r*h)},round:function(t,e){var i=""+t,n=i.indexOf(".");return parseFloat(i.substring(0,n+1+e))},dist:function(t,e){var i=t.x-e.x,n=t.y-e.y;return o(i*i+n*n)},closest:function(t,e){var i,n,r=h(2,63);return t.forEach(function(t,s){(n=d.dist(e,t))<r&&(r=n,i=s)}),{mdist:r,mpos:i}},abcratio:function(t,i){if(2!==i&&3!==i)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var n=h(t,i)+h(1-t,i);return e((n-1)/n)},projectionratio:function(t,e){if(2!==e&&3!==e)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var i=h(1-t,e);return i/(h(t,e)+i)},lli8:function(t,e,i,n,r,s,o,h){var p=(t-i)*(s-h)-(e-n)*(r-o);return 0!=p&&{x:((t*n-e*i)*(r-o)-(t-i)*(r*h-s*o))/p,y:((t*n-e*i)*(s-h)-(e-n)*(r*h-s*o))/p}},lli4:function(t,e,i,n){var r=t.x,s=t.y,o=e.x,h=e.y,p=i.x,u=i.y,a=n.x,f=n.y;return d.lli8(r,s,o,h,p,u,a,f)},lli:function(t,e){return d.lli4(t,t.c,e,e.c)},makeline:function(t,e){var i=f,n=t.x,r=t.y,s=e.x,o=e.y,h=(s-n)/3,p=(o-r)/3;return new i(n,r,n+h,r+p,n+2*h,r+2*p,s,o)},findbbox:function(t){var e=c,i=c,n=y,r=y;return t.forEach(function(t){var s=t.bbox();e>s.x.min&&(e=s.x.min),i>s.y.min&&(i=s.y.min),n<s.x.max&&(n=s.x.max),r<s.y.max&&(r=s.y.max)}),{x:{min:e,mid:(e+n)/2,max:n,size:n-e},y:{min:i,mid:(i+r)/2,max:r,size:r-i}}},shapeintersections:function(t,e,i,n,r){if(!d.bboxoverlap(e,n))return[];var s=[],o=[t.startcap,t.forward,t.back,t.endcap],h=[i.startcap,i.forward,i.back,i.endcap];return o.forEach(function(e){e.virtual||h.forEach(function(n){if(!n.virtual){var o=e.intersects(n,r);o.length>0&&(o.c1=e,o.c2=n,o.s1=t,o.s2=i,s.push(o))}})}),s},makeshape:function(t,e,i){var n=e.points.length,r=t.points.length,s=d.makeline(e.points[n-1],t.points[0]),o=d.makeline(t.points[r-1],e.points[0]),h={startcap:s,forward:t,back:e,endcap:o,bbox:d.findbbox([s,t,e,o])},p=d;return h.intersections=function(t){return p.shapeintersections(h,h.bbox,t,t.bbox,i)},h},getminmax:function(t,e,i){if(!i)return{min:0,max:0};var n,r,s=c,o=y;-1===i.indexOf(0)&&(i=[0].concat(i)),-1===i.indexOf(1)&&i.push(1);for(var h=0,p=i.length;h<p;h++)n=i[h],(r=t.get(n))[e]<s&&(s=r[e]),r[e]>o&&(o=r[e]);return{min:s,mid:(s+o)/2,max:o,size:o-s}},align:function(t,e){var r=e.p1.x,o=e.p1.y,h=-s(e.p2.y-o,e.p2.x-r);return t.map(function(t){return{x:(t.x-r)*i(h)-(t.y-o)*n(h),y:(t.x-r)*n(h)+(t.y-o)*i(h)}})},roots:function(t,e){e=e||{p1:{x:0,y:0},p2:{x:1,y:0}};var n=t.length-1,s=d.align(t,e),h=function(t){return 0<=t&&t<=1};if(2===n){if(0!==(x=(g=s[0].y)-2*(m=s[1].y)+(v=s[2].y))){var u=-o(m*m-g*v),f=-g+m;return[-(u+f)/x,-(-u+f)/x].filter(h)}return m!==v&&0===x?[(2*m-v)/(2*m-2*v)].filter(h):[]}var l=s[0].y,c=s[1].y,y=s[2].y,x=3*c-l-3*y+s[3].y,g=3*l-6*c+3*y,m=-3*l+3*c,v=l;if(d.approximately(x,0)){if(d.approximately(g,0))return d.approximately(m,0)?[]:[-v/m].filter(h);var w=2*g;return[((b=o(m*m-4*g*v))-m)/w,(-m-b)/w].filter(h)}var b,z,O=(s=(3*(m/=x)-(g/=x)*g)/3)/3,$=(b=(2*g*g*g-9*g*m+27*(v/=x))/27)/2,_=$*$+O*O*O;if(_<0){var M=-s/3,k=o(M*M*M),P=-b/(2*k),R=r(P<-1?-1:P>1?1:P),L=2*p(k);return[L*i(R/3)-g/3,L*i((R+a)/3)-g/3,L*i((R+2*a)/3)-g/3].filter(h)}if(0===_)return[2*(z=$<0?p(-$):-p($))-g/3,-z-g/3].filter(h);var S=o(_);return[(z=p(-$+S))-p($+S)-g/3].filter(h)},droots:function(t){if(3===t.length){var e=t[0],i=t[1],n=t[2],r=e-2*i+n;if(0!==r){var s=-o(i*i-e*n),h=-e+i;return[-(s+h)/r,-(-s+h)/r]}return i!==n&&0===r?[(2*i-n)/(2*(i-n))]:[]}if(2===t.length)return(e=t[0])!==(i=t[1])?[e/(e-i)]:[]},curvature:function(t,e,i){var n,r,s=d.derive(e),p=s[0],u=s[1],a=d.compute(t,p),f=d.compute(t,u);return i?(n=o(h(a.y*f.z-f.y*a.z,2)+h(a.z*f.x-f.z*a.x,2)+h(a.x*f.y-f.x*a.y,2)),r=h(a.x*a.x+a.y*a.y+a.z*a.z,2/3)):(n=a.x*f.y-a.y*f.x,r=h(a.x*a.x+a.y*a.y,2/3)),0===n||0===r?{k:0,r:0}:{k:n/r,r:r/n}},inflections:function(t){if(t.length<4)return[];var e=d.align(t,{p1:t[0],p2:t.slice(-1)[0]}),i=e[2].x*e[1].y,n=e[3].x*e[1].y,r=e[1].x*e[2].y,s=18*(-3*i+2*n+3*r-(f=e[3].x*e[2].y)),o=18*(3*i-n-3*r),h=18*(r-i);if(d.approximately(s,0)){if(!d.approximately(o,0)){var p=-h/o;if(0<=p&&p<=1)return[p]}return[]}var u=o*o-4*s*h,a=Math.sqrt(u),f=2*s;return d.approximately(f,0)?[]:[(a-o)/f,-(o+a)/f].filter(function(t){return 0<=t&&t<=1})},bboxoverlap:function(t,i){var n,r,s,o,h,p=["x","y"],u=p.length;for(n=0;n<u;n++)if(s=t[r=p[n]].mid,o=i[r].mid,h=(t[r].size+i[r].size)/2,e(s-o)>=h)return!1;return!0},expandbox:function(t,e){e.x.min<t.x.min&&(t.x.min=e.x.min),e.y.min<t.y.min&&(t.y.min=e.y.min),e.z&&e.z.min<t.z.min&&(t.z.min=e.z.min),e.x.max>t.x.max&&(t.x.max=e.x.max),e.y.max>t.y.max&&(t.y.max=e.y.max),e.z&&e.z.max>t.z.max&&(t.z.max=e.z.max),t.x.mid=(t.x.min+t.x.max)/2,t.y.mid=(t.y.min+t.y.max)/2,t.z&&(t.z.mid=(t.z.min+t.z.max)/2),t.x.size=t.x.max-t.x.min,t.y.size=t.y.max-t.y.min,t.z&&(t.z.size=t.z.max-t.z.min)},pairiteration:function(t,e,i){var n=t.bbox(),r=e.bbox(),s=1e5,o=i||.5;if(n.x.size+n.y.size<o&&r.x.size+r.y.size<o)return[(s*(t._t1+t._t2)/2|0)/s+"/"+(s*(e._t1+e._t2)/2|0)/s];var h=t.split(.5),p=e.split(.5),u=[{left:h.left,right:p.left},{left:h.left,right:p.right},{left:h.right,right:p.right},{left:h.right,right:p.left}];u=u.filter(function(t){return d.bboxoverlap(t.left.bbox(),t.right.bbox())});var a=[];return 0===u.length?a:(u.forEach(function(t){a=a.concat(d.pairiteration(t.left,t.right,o))}),a=a.filter(function(t,e){return a.indexOf(t)===e}))},getccenter:function(t,e,r){var o,h=e.x-t.x,p=e.y-t.y,u=r.x-e.x,f=r.y-e.y,c=h*i(l)-p*n(l),y=h*n(l)+p*i(l),x=u*i(l)-f*n(l),g=u*n(l)+f*i(l),m=(t.x+e.x)/2,v=(t.y+e.y)/2,w=(e.x+r.x)/2,b=(e.y+r.y)/2,z=m+c,O=v+y,$=w+x,_=b+g,M=d.lli8(m,v,z,O,w,b,$,_),k=d.dist(M,t),P=s(t.y-M.y,t.x-M.x),R=s(e.y-M.y,e.x-M.x),L=s(r.y-M.y,r.x-M.x);return P<L?((P>R||R>L)&&(P+=a),P>L&&(o=L,L=P,P=o)):L<R&&R<P?(o=L,L=P,P=o):L+=a,M.s=P,M.e=L,M.r=k,M},numberSort:function(t,e){return t-e}},t.exports=d}),o=r(function(t){var e,i;e=s,(i=function(t){this.curves=[],this._3d=!1,t&&(this.curves=t,this._3d=this.curves[0]._3d)}).prototype={valueOf:function(){return this.toString()},toString:function(){return"["+this.curves.map(function(t){return e.pointsToString(t.points)}).join(", ")+"]"},addCurve:function(t){this.curves.push(t),this._3d=this._3d||t._3d},length:function(){return this.curves.map(function(t){return t.length()}).reduce(function(t,e){return t+e})},curve:function(t){return this.curves[t]},bbox:function(){for(var t=this.curves,i=t[0].bbox(),n=1;n<t.length;n++)e.expandbox(i,t[n].bbox());return i},offset:function(t){var e=[];return this.curves.forEach(function(i){e=e.concat(i.offset(t))}),new i(e)}},t.exports=i});var h=function(t){var e,i,n,r,s,o,h=(t=t.replace(/,/g," ").replace(/-/g," - ").replace(/-\s+/g,"-").replace(/([a-zA-Z])/g," $1 ")).replace(/([a-zA-Z])\s?/g,"|$1").split("|"),p=h.length,u=[],a=0,f=0,l=0,c=0,y=0,x=0,d=0,g=0,m="";for(e=1;e<p;e++)if(r=(n=(i=h[e]).substring(0,1)).toLowerCase(),s=(u=(u=i.replace(n,"").trim().split(" ")).filter(function(t){return""!==t}).map(parseFloat)).length,"m"===r){if(m+="M ","m"===n?(l+=u[0],c+=u[1]):(l=u[0],c=u[1]),a=l,f=c,m+=l+" "+c+" ",s>2)for(o=0;o<s;o+=2)"m"===n?(l+=u[o],c+=u[o+1]):(l=u[o],c=u[o+1]),m+=["L",l,c,""].join(" ")}else if("l"===r)for(o=0;o<s;o+=2)"l"===n?(l+=u[o],c+=u[o+1]):(l=u[o],c=u[o+1]),m+=["L",l,c,""].join(" ");else if("h"===r)for(o=0;o<s;o++)"h"===n?l+=u[o]:l=u[o],m+=["L",l,c,""].join(" ");else if("v"===r)for(o=0;o<s;o++)"v"===n?c+=u[o]:c=u[o],m+=["L",l,c,""].join(" ");else if("q"===r)for(o=0;o<s;o+=4)"q"===n?(y=l+u[o],x=c+u[o+1],l+=u[o+2],c+=u[o+3]):(y=u[o],x=u[o+1],l=u[o+2],c=u[o+3]),m+=["Q",y,x,l,c,""].join(" ");else if("t"===r)for(o=0;o<s;o+=2)y=l+(l-y),x=c+(c-x),"t"===n?(l+=u[o],c+=u[o+1]):(l=u[o],c=u[o+1]),m+=["Q",y,x,l,c,""].join(" ");else if("c"===r)for(o=0;o<s;o+=6)"c"===n?(y=l+u[o],x=c+u[o+1],d=l+u[o+2],g=c+u[o+3],l+=u[o+4],c+=u[o+5]):(y=u[o],x=u[o+1],d=u[o+2],g=u[o+3],l=u[o+4],c=u[o+5]),m+=["C",y,x,d,g,l,c,""].join(" ");else if("s"===r)for(o=0;o<s;o+=4)y=l+(l-d),x=c+(c-g),"s"===n?(d=l+u[o],g=c+u[o+1],l+=u[o+2],c+=u[o+3]):(d=u[o],g=u[o+1],l=u[o+2],c=u[o+3]),m+=["C",y,x,d,g,l,c,""].join(" ");else"z"===r&&(m+="Z ",l=a,c=f);return m.trim()},p={x:!1,y:!1};function u(t,e,i){if("Z"!==e){if("M"!==e){var n=[!1,p.x,p.y].concat(i),r=new(t.bind.apply(t,n)),s=i.slice(-2);return p={x:s[0],y:s[1]},r}p={x:i[0],y:i[1]}}}var a=function(t,e){for(var i,n,r=h(e).split(" "),s=new RegExp("[MLCQZ]",""),o=[],p={C:6,Q:4,L:2,M:2};r.length;)i=r.splice(0,1)[0],s.test(i)&&(n=u(t,i,r.splice(0,p[i]).map(parseFloat)))&&o.push(n);return new t.PolyBezier(o)},f=r(function(t){!function(){var e=Math.abs,i=Math.min,n=Math.max,r=Math.cos,h=Math.sin,p=Math.acos,u=Math.sqrt,f=Math.PI,l={x:0,y:0,z:0},c=s,y=o,x=function(t){var i=t&&t.forEach?t:[].slice.call(arguments),n=!1;if("object"==typeof i[0]){n=i.length;var r=[];i.forEach(function(t){["x","y","z"].forEach(function(e){void 0!==t[e]&&r.push(t[e])})}),i=r}var s=!1,o=i.length;if(n){if(n>4){if(1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");s=!0}}else if(6!==o&&8!==o&&9!==o&&12!==o&&1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");var h=!s&&(9===o||12===o)||t&&t[0]&&void 0!==t[0].z;this._3d=h;for(var p=[],u=0,a=h?3:2;u<o;u+=a){var f={x:i[u],y:i[u+1]};h&&(f.z=i[u+2]),p.push(f)}this.order=p.length-1,this.points=p;var l=["x","y"];h&&l.push("z"),this.dims=l,this.dimlen=l.length,function(t){for(var i=t.order,n=t.points,r=c.align(n,{p1:n[0],p2:n[i]}),s=0;s<r.length;s++)if(e(r[s].y)>1e-4)return void(t._linear=!1);t._linear=!0}(this),this._t1=0,this._t2=1,this.update()},d=a;function g(t,e,i,n,r){void 0===r&&(r=.5);var s=c.projectionratio(r,t),o=1-s,h={x:s*e.x+o*n.x,y:s*e.y+o*n.y},p=c.abcratio(r,t);return{A:{x:i.x+(i.x-h.x)/p,y:i.y+(i.y-h.y)/p},B:i,C:h}}x.SVGtoBeziers=function(t){return d(x,t)},x.quadraticFromPoints=function(t,e,i,n){if(void 0===n&&(n=.5),0===n)return new x(e,e,i);if(1===n)return new x(t,e,e);var r=g(2,t,e,i,n);return new x(t,r.A,i)},x.cubicFromPoints=function(t,e,i,n,r){void 0===n&&(n=.5);var s=g(3,t,e,i,n);void 0===r&&(r=c.dist(e,s.C));var o=r*(1-n)/n,h=c.dist(t,i),p=(i.x-t.x)/h,u=(i.y-t.y)/h,a=r*p,f=r*u,l=o*p,y=o*u,d=e.x-a,m=e.y-f,v=e.x+l,w=e.y+y,b=s.A,z=b.x+(d-b.x)/(1-n),O=b.y+(m-b.y)/(1-n),$=b.x+(v-b.x)/n,_=b.y+(w-b.y)/n,M={x:t.x+(z-t.x)/n,y:t.y+(O-t.y)/n},k={x:i.x+($-i.x)/(1-n),y:i.y+(_-i.y)/(1-n)};return new x(t,M,k,i)};var m=function(){return c};x.getUtils=m,x.PolyBezier=y,x.prototype={getUtils:m,valueOf:function(){return this.toString()},toString:function(){return c.pointsToString(this.points)},toSVG:function(t){if(this._3d)return!1;for(var e=this.points,i=["M",e[0].x,e[0].y,2===this.order?"Q":"C"],n=1,r=e.length;n<r;n++)i.push(e[n].x),i.push(e[n].y);return i.join(" ")},update:function(){this._lut=[],this.dpoints=c.derive(this.points,this._3d),this.computedirection()},computedirection:function(){var t=this.points,e=c.angle(t[0],t[this.order],t[1]);this.clockwise=e>0},length:function(){return c.length(this.derivative.bind(this))},_lut:[],getLUT:function(t){if(t=t||100,this._lut.length===t)return this._lut;this._lut=[],t--;for(var e=0;e<=t;e++)this._lut.push(this.compute(e/t));return this._lut},on:function(t,e){e=e||5;for(var i,n=this.getLUT(),r=[],s=0,o=0;o<n.length;o++)i=n[o],c.dist(i,t)<e&&(r.push(i),s+=o/n.length);return!!r.length&&s/r.length},project:function(t){var e=this.getLUT(),i=e.length-1,n=c.closest(e,t),r=n.mdist,s=n.mpos;if(0===s||s===i){var o=s/i,h=this.compute(o);return h.t=o,h.d=r,h}var p,u,a,f=(s+1)/i,l=.1/i;for(r+=1,p=o=(s-1)/i;o<f+l;o+=l)u=this.compute(o),(a=c.dist(t,u))<r&&(r=a,p=o);return(u=this.compute(p)).t=p,u.d=r,u},get:function(t){return this.compute(t)},point:function(t){return this.points[t]},compute:function(t){return c.compute(t,this.points,this._3d)},raise:function(){for(var t,e,i=this.points,n=[i[0]],r=i.length,s=1;s<r;s++)t=i[s],e=i[s-1],n[s]={x:(r-s)/r*t.x+s/r*e.x,y:(r-s)/r*t.y+s/r*e.y};return n[r]=i[r-1],new x(n)},derivative:function(t){var e,i,n=1-t,r=0,s=this.dpoints[0];2===this.order&&(s=[s[0],s[1],l],e=n,i=t),3===this.order&&(e=n*n,i=n*t*2,r=t*t);var o={x:e*s[0].x+i*s[1].x+r*s[2].x,y:e*s[0].y+i*s[1].y+r*s[2].y};return this._3d&&(o.z=e*s[0].z+i*s[1].z+r*s[2].z),o},curvature:function(t){return c.curvature(t,this.points,this._3d)},inflections:function(){return c.inflections(this.points)},normal:function(t){return this._3d?this.__normal3(t):this.__normal2(t)},__normal2:function(t){var e=this.derivative(t),i=u(e.x*e.x+e.y*e.y);return{x:-e.y/i,y:e.x/i}},__normal3:function(t){var e=this.derivative(t),i=this.derivative(t+.01),n=u(e.x*e.x+e.y*e.y+e.z*e.z),r=u(i.x*i.x+i.y*i.y+i.z*i.z);e.x/=n,e.y/=n,e.z/=n,i.x/=r,i.y/=r,i.z/=r;var s={x:i.y*e.z-i.z*e.y,y:i.z*e.x-i.x*e.z,z:i.x*e.y-i.y*e.x},o=u(s.x*s.x+s.y*s.y+s.z*s.z);s.x/=o,s.y/=o,s.z/=o;var h=[s.x*s.x,s.x*s.y-s.z,s.x*s.z+s.y,s.x*s.y+s.z,s.y*s.y,s.y*s.z-s.x,s.x*s.z-s.y,s.y*s.z+s.x,s.z*s.z];return{x:h[0]*e.x+h[1]*e.y+h[2]*e.z,y:h[3]*e.x+h[4]*e.y+h[5]*e.z,z:h[6]*e.x+h[7]*e.y+h[8]*e.z}},hull:function(t){var e,i=this.points,n=[],r=[],s=0,o=0,h=0;for(r[s++]=i[0],r[s++]=i[1],r[s++]=i[2],3===this.order&&(r[s++]=i[3]);i.length>1;){for(n=[],o=0,h=i.length-1;o<h;o++)e=c.lerp(t,i[o],i[o+1]),r[s++]=e,n.push(e);i=n}return r},split:function(t,e){if(0===t&&e)return this.split(e).left;if(1===e)return this.split(t).right;var i=this.hull(t),n={left:2===this.order?new x([i[0],i[3],i[5]]):new x([i[0],i[4],i[7],i[9]]),right:2===this.order?new x([i[5],i[4],i[2]]):new x([i[9],i[8],i[6],i[3]]),span:i};return n.left._t1=c.map(0,0,1,this._t1,this._t2),n.left._t2=c.map(t,0,1,this._t1,this._t2),n.right._t1=c.map(t,0,1,this._t1,this._t2),n.right._t2=c.map(1,0,1,this._t1,this._t2),e?(e=c.map(e,t,1,0,1),n.right.split(e).left):n},extrema:function(){var t,e,i=this.dims,n={},r=[];return i.forEach(function(i){e=function(t){return t[i]},t=this.dpoints[0].map(e),n[i]=c.droots(t),3===this.order&&(t=this.dpoints[1].map(e),n[i]=n[i].concat(c.droots(t))),n[i]=n[i].filter(function(t){return t>=0&&t<=1}),r=r.concat(n[i].sort(c.numberSort))}.bind(this)),r=r.sort(c.numberSort).filter(function(t,e){return r.indexOf(t)===e}),n.values=r,n},bbox:function(){var t=this.extrema(),e={};return this.dims.forEach(function(i){e[i]=c.getminmax(this,i,t[i])}.bind(this)),e},overlaps:function(t){var e=this.bbox(),i=t.bbox();return c.bboxoverlap(e,i)},offset:function(t,e){if(void 0!==e){var i=this.get(t),n=this.normal(t),r={c:i,n:n,x:i.x+n.x*e,y:i.y+n.y*e};return this._3d&&(r.z=i.z+n.z*e),r}if(this._linear){var s=this.normal(0),o=this.points.map(function(e){var i={x:e.x+t*s.x,y:e.y+t*s.y};return e.z&&n.z&&(i.z=e.z+t*s.z),i});return[new x(o)]}return this.reduce().map(function(e){return e.scale(t)})},simple:function(){if(3===this.order){var t=c.angle(this.points[0],this.points[3],this.points[1]),i=c.angle(this.points[0],this.points[3],this.points[2]);if(t>0&&i<0||t<0&&i>0)return!1}var n=this.normal(0),r=this.normal(1),s=n.x*r.x+n.y*r.y;return this._3d&&(s+=n.z*r.z),e(p(s))<f/3},reduce:function(){var t,i,n=0,r=0,s=[],o=[],h=this.extrema().values;for(-1===h.indexOf(0)&&(h=[0].concat(h)),-1===h.indexOf(1)&&h.push(1),n=h[0],t=1;t<h.length;t++)r=h[t],(i=this.split(n,r))._t1=n,i._t2=r,s.push(i),n=r;return s.forEach(function(t){for(n=0,r=0;r<=1;)for(r=n+.01;r<=1.01;r+=.01)if(!(i=t.split(n,r)).simple()){if(e(n-(r-=.01))<.01)return[];(i=t.split(n,r))._t1=c.map(n,0,1,t._t1,t._t2),i._t2=c.map(r,0,1,t._t1,t._t2),o.push(i),n=r;break}n<1&&((i=t.split(n,1))._t1=c.map(n,0,1,t._t1,t._t2),i._t2=t._t2,o.push(i))}),o},scale:function(t){var e=this.order,i=!1;if("function"==typeof t&&(i=t),i&&2===e)return this.raise().scale(i);var n=this.clockwise,r=i?i(0):t,s=i?i(1):t,o=[this.offset(0,10),this.offset(1,10)],h=c.lli4(o[0],o[0].c,o[1],o[1].c);if(!h)throw new Error("cannot scale this curve. Try reducing it first.");var p=this.points,a=[];return[0,1].forEach(function(t){var i=a[t*e]=c.copy(p[t*e]);i.x+=(t?s:r)*o[t].n.x,i.y+=(t?s:r)*o[t].n.y}.bind(this)),i?([0,1].forEach(function(r){if(2!==this.order||!r){var s=p[r+1],o={x:s.x-h.x,y:s.y-h.y},f=i?i((r+1)/e):t;i&&!n&&(f=-f);var l=u(o.x*o.x+o.y*o.y);o.x/=l,o.y/=l,a[r+1]={x:s.x+f*o.x,y:s.y+f*o.y}}}.bind(this)),new x(a)):([0,1].forEach(function(t){if(2!==this.order||!t){var i=a[t*e],n=this.derivative(t),r={x:i.x+n.x,y:i.y+n.y};a[t+1]=c.lli4(i,r,h,p[t+1])}}.bind(this)),new x(a))},outline:function(t,e,i,n){e=void 0===e?t:e;var r,s=this.reduce(),o=s.length,h=[],p=[],u=0,a=this.length(),f=void 0!==i&&void 0!==n;function l(t,e,i,n,r){return function(s){var o=n/i,h=(n+r)/i,p=e-t;return c.map(s,0,1,t+o*p,t+h*p)}}s.forEach(function(r){z=r.length(),f?(h.push(r.scale(l(t,i,a,u,z))),p.push(r.scale(l(-e,-n,a,u,z)))):(h.push(r.scale(t)),p.push(r.scale(-e))),u+=z}),p=p.map(function(t){return(r=t.points)[3]?t.points=[r[3],r[2],r[1],r[0]]:t.points=[r[2],r[1],r[0]],t}).reverse();var x=h[0].points[0],d=h[o-1].points[h[o-1].points.length-1],g=p[o-1].points[p[o-1].points.length-1],m=p[0].points[0],v=c.makeline(g,x),w=c.makeline(d,m),b=[v].concat(h).concat([w]).concat(p),z=b.length;return new y(b)},outlineshapes:function(t,e,i){e=e||t;for(var n=this.outline(t,e).curves,r=[],s=1,o=n.length;s<o/2;s++){var h=c.makeshape(n[s],n[o-s],i);h.startcap.virtual=s>1,h.endcap.virtual=s<o/2-1,r.push(h)}return r},intersects:function(t,e){return t?t.p1&&t.p2?this.lineIntersects(t):(t instanceof x&&(t=t.reduce()),this.curveintersects(this.reduce(),t,e)):this.selfintersects(e)},lineIntersects:function(t){var e=i(t.p1.x,t.p2.x),r=i(t.p1.y,t.p2.y),s=n(t.p1.x,t.p2.x),o=n(t.p1.y,t.p2.y),h=this;return c.roots(this.points,t).filter(function(t){var i=h.get(t);return c.between(i.x,e,s)&&c.between(i.y,r,o)})},selfintersects:function(t){var e,i,n,r,s=this.reduce(),o=s.length-2,h=[];for(e=0;e<o;e++)n=s.slice(e,e+1),r=s.slice(e+2),i=this.curveintersects(n,r,t),h=h.concat(i);return h},curveintersects:function(t,e,i){var n=[];t.forEach(function(t){e.forEach(function(e){t.overlaps(e)&&n.push({left:t,right:e})})});var r=[];return n.forEach(function(t){var e=c.pairiteration(t.left,t.right,i);e.length>0&&(r=r.concat(e))}),r},arcs:function(t){t=t||.5;return this._iterate(t,[])},_error:function(t,i,n,r){var s=(r-n)/4,o=this.get(n+s),h=this.get(r-s),p=c.dist(t,i),u=c.dist(t,o),a=c.dist(t,h);return e(u-p)+e(a-p)},_iterate:function(t,e){var i,n=0,s=1;do{i=0,s=1;var o,p,u,a,f,l=this.get(n),y=!1,x=!1,d=s,g=1;do{if(x=y,a=u,d=(n+s)/2,o=this.get(d),p=this.get(s),(u=c.getccenter(l,o,p)).interval={start:n,end:s},y=this._error(u,l,n,s)<=t,(f=x&&!y)||(g=s),y){if(s>=1){if(u.interval.end=g=1,a=u,s>1){var m={x:u.x+u.r*r(u.e),y:u.y+u.r*h(u.e)};u.e+=c.angle({x:u.x,y:u.y},m,this.get(1))}break}s+=(s-n)/2}else s=d}while(!f&&i++<100);if(i>=100)break;a=a||u,e.push(a),n=g}while(s<1);return e}},t.exports=x}()}),l=f;function c(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new i,this.ops=[]}function y(t,e,i){if(t.x===e.x&&t.y===e.y)return!1;let n=t.angle(e)-90;return(new c).move(t.shift(n,i)).line(e.shift(n,i))}function x(t){return(new c).move(new n(t.points[0].x,t.points[0].y)).curve(new n(t.points[1].x,t.points[1].y),new n(t.points[2].x,t.points[2].y),new n(t.points[3].x,t.points[3].y))}function d(t,e=!1){let i,n=(new c).move(t[0].ops[0].to);for(let e of t)for(let t of e.ops){if("curve"===t.type)n.curve(t.cp1,t.cp2,t.to);else{if("close"===t.type)throw new Error("Cannot join a closed paths with another");i&&!t.to.sitsRoughlyOn(i)&&n.line(t.to)}t.to&&(i=t.to)}return e&&n.close(),n}function g(t,e){let i,r,s,o,h=0;for(let p=0;p<=100;p++){if(s=p/100,r=new n((r=e.get(s)).x,r.y),p>0){if(h+(o=r.dist(i))>t)return r;h+=o}i=r}}function m(t){let e=t.from,i=t.to;return e.x===i.x?e.y<i.y?{topLeft:e,bottomRight:i}:{topLeft:i,bottomRight:e}:e.y===i.y?e.x<i.x?{topLeft:e,bottomRight:i}:{topLeft:i,bottomRight:e}:e.x<i.x?e.y<i.y?{topLeft:e,bottomRight:i}:{topLeft:new n(e.x,i.y),bottomRight:new n(i.x,e.y)}:e.x>i.x?e.y<i.y?{topLeft:new n(i.x,e.y),bottomRight:new n(e.x,i.y)}:{topLeft:new n(i.x,i.y),bottomRight:new n(e.x,e.y)}:void 0}function v(t){let e=t.bbox();return{topLeft:new n(e.x.min,e.y.min),bottomRight:new n(e.x.max,e.y.max)}}function w(t,e){if(t&&"object"==typeof t)if("number"==typeof t.x)e.push(t);else for(let i of t)e.push(i)}function b(t){return t.charAt(0).toUpperCase()+t.slice(1)}function z(t){return`_macro_${t}`}function O(t,e,i,r){let s=t.slope(e),o=i.slope(r);if(s===o)return!1;if(t.x===e.x)return new n(t.x,o*t.x+(i.y-o*i.x));if(i.x===r.x)return new n(i.x,s*i.x+(t.y-s*t.x));{t.x>e.x&&(t=e.copy()),i.x>r.x&&(i=r.copy());let h=t.y-s*t.x,p=(i.y-o*i.x-h)/(s-o);return new n(p,s*p+h)}}function $(t,e,i,n){let r=O(t,e,i,n);if(!r)return!1;let s=t.dist(e),o=i.dist(n),h=t.dist(r)+r.dist(e),p=i.dist(r)+r.dist(n);return Math.round(s)==Math.round(h)&&Math.round(o)==Math.round(p)&&r}function _(t,e,i,n=1e6){if(t.sitsOn(i))return!0;if(e.sitsOn(i))return!0;let r=i.dx(t)*e.dy(t)-i.dy(t)*e.dx(t);return 0===Math.abs(Math.round(r*n)/n)}function M(t,e,i,n=1e6){if(!_(t,e,i,n))return!1;let r=t.dist(e),s=t.dist(i)+i.dist(e);return Math.round(r)==Math.round(s)}function k(t,e,i,n,r){if(t.sitsOn(r))return!0;if(n.sitsOn(r))return!0;let s=new l({x:t.x,y:t.y},{x:e.x,y:e.y},{x:i.x,y:i.y},{x:n.x,y:n.y}).intersects({p1:{x:r.x-1,y:r.y},p2:{x:r.x+1,y:r.y}});return s.length>0&&s.shift()}function P(t,e="metric"){return"imperial"===e?A(t/25.4)+'"':A(t/10)+"cm"}function R(t,e,i,r,s,o){let h=[],p=new l({x:i.x,y:i.y},{x:r.x,y:r.y},{x:s.x,y:s.y},{x:o.x,y:o.y}),u={p1:{x:t.x,y:t.y},p2:{x:e.x,y:e.y}};for(let t of p.intersects(u)){let e=p.get(t);h.push(new n(e.x,e.y))}return 0!==h.length&&(1===h.length?h[0]:h)}function L(t,e,i,r,s,o,h,p){let u=[],a=new l({x:t.x,y:t.y},{x:e.x,y:e.y},{x:i.x,y:i.y},{x:r.x,y:r.y}),f=new l({x:s.x,y:s.y},{x:o.x,y:o.y},{x:h.x,y:h.y},{x:p.x,y:p.y});for(let t of a.intersects(f,.005)){let e=a.get(t.substr(0,t.indexOf("/")));u.push(new n(e.x,e.y))}if(0===u.length)return!1;if(1===u.length)return u.shift();{let t=[];for(let e of u){let i=!1;for(let n of t)e.sitsRoughlyOn(n)&&(i=!0);i||t.push(e)}return t}}function S(t,e,i,r,s="x"){let o=r.x-i.x,h=r.y-i.y,p=Math.pow(o,2)+Math.pow(h,2),u=2*(o*(i.x-t.x)+h*(i.y-t.y)),a=Math.pow(i.x-t.x,2)+Math.pow(i.y-t.y,2)-Math.pow(e,2),f=Math.pow(u,2)-4*p*a;if(p<=1e-7||f<0)return!1;if(0===f){let t=-1*u/(2*p);return[new n(i.x+t*o,i.y+t*h)]}{let t=(-1*u+Math.sqrt(f))/(2*p),e=new n(i.x+t*o,i.y+t*h);t=(-1*u-Math.sqrt(f))/(2*p);let r=new n(i.x+t*o,i.y+t*h);return"x"===s&&e.x<=r.x||"y"===s&&e.y<=r.y?[e,r]:[r,e]}}function j(t,e,i=500){let r,s=1/0,o=1/0;"bottom"===e&&(o=-1/0),"right"===e&&(s=-1/0);for(let n=0;n<i;n++)r=t.get(n/i),("top"===e&&r.y<o||"bottom"===e&&r.y>o||"right"===e&&r.x>s||"left"===e&&r.x<s)&&(s=r.x,o=r.y);return new n(s,o)}function A(t){return Math.round(100*t)/100}function E(t,e){return`stroke: hsl(${330/e*(t-1)}, 100%, 35%);`}c.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},c.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},c.prototype.curve=function(t,e,i){return this.ops.push({type:"curve",cp1:t,cp2:e,to:i}),this},c.prototype._curve=function(t,e){let i=this.ops.slice(-1).pop().to;return this.ops.push({type:"curve",cp1:i,cp2:t,to:e}),this},c.prototype.curve_=function(t,e){let i=e.copy();return this.ops.push({type:"curve",cp1:t,cp2:i,to:e}),this},c.prototype.close=function(){return this.ops.push({type:"close"}),this},c.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},c.prototype.asPathstring=function(){let t="";for(let e of this.ops)switch(e.type){case"move":t+=`M ${e.to.x},${e.to.y}`;break;case"line":t+=` L ${e.to.x},${e.to.y}`;break;case"curve":t+=` C ${e.cp1.x},${e.cp1.y} ${e.cp2.x},${e.cp2.y} ${e.to.x},${e.to.y}`;break;case"close":t+=" z"}return t},c.prototype.offset=function(t){return function(t,e){let i,n=[],r=!1;for(let s in t.ops){let o=t.ops[s];if("line"===o.type){let t=y(i,o.to,e);t&&n.push(t)}else if("curve"===o.type){let t,r;t=i.sitsRoughlyOn(o.cp1)?(new c).move(i).curve(o.cp1,o.cp2,o.to).shiftAlong(2):o.cp1,r=o.cp2.sitsRoughlyOn(o.to)?(new c).move(o.to).curve(o.cp2,o.cp1,i).shiftAlong(2):o.cp2;let s=new l({x:i.x,y:i.y},{x:t.x,y:t.y},{x:r.x,y:r.y},{x:o.to.x,y:o.to.y});for(let t of s.offset(e))n.push(x(t))}else"close"===o.type&&(r=!0);o.to&&(i=o.to)}return d(n,r)}(this,t)},c.prototype.length=function(){let t,e,i=0;for(let n in this.ops){let r=this.ops[n];"move"===r.type?e=r.to:"line"===r.type?i+=t.dist(r.to):"curve"===r.type?i+=new l({x:t.x,y:t.y},{x:r.cp1.x,y:r.cp1.y},{x:r.cp2.x,y:r.cp2.y},{x:r.to.x,y:r.to.y}).length():"close"===r.type&&(i+=t.dist(e)),r.to&&(t=r.to)}return A(i)},c.prototype.start=function(){return this.ops[0].to},c.prototype.end=function(){let t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},c.prototype.boundary=function(){if(this.topLeft)return this;let t,e=new n(1/0,1/0),i=new n(-1/0,-1/0),r=[];for(let n in this.ops){let s=this.ops[n];if("move"===s.type||"line"===s.type)s.to.x<e.x&&(e.x=s.to.x,r.leftOp=n),s.to.y<e.y&&(e.y=s.to.y,r.topOp=n),s.to.x>i.x&&(i.x=s.to.x,r.rightOp=n),s.to.y>i.y&&(i.y=s.to.y,r.bottomOp=n);else if("curve"===s.type){let o=new l({x:t.x,y:t.y},{x:s.cp1.x,y:s.cp1.y},{x:s.cp2.x,y:s.cp2.y},{x:s.to.x,y:s.to.y}).bbox();o.x.min<e.x&&(e.x=o.x.min,r.leftOp=n),o.y.min<e.y&&(e.y=o.y.min,r.topOp=n),o.x.max>i.x&&(i.x=o.x.max,r.rightOp=n),o.y.max>i.y&&(i.y=o.y.max,r.bottomOp=n)}s.to&&(t=s.to)}this.topLeft=e,this.bottomRight=i;for(let t of["top","left","bottom","right"]){let e=t+"Op";this[e]=this.ops[r[e]],this[e].from="move"===this[e].type?this[e].to:this.ops[r[e]-1].to}return this},c.prototype.clone=function(){let t=new c;t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[];for(let e in this.ops){let i=this.ops[e];t.ops[e]={type:i.type},"move"===i.type||"line"===i.type?t.ops[e].to=i.to.clone():"curve"===i.type&&(t.ops[e].to=i.to.clone(),t.ops[e].cp1=i.cp1.clone(),t.ops[e].cp2=i.cp2.clone())}return t},c.prototype.join=function(t,e=!1){return d([this,t],e)},c.prototype.shiftAlong=function(t){let e,i=0;for(let n in this.ops){let r=this.ops[n];if("line"===r.type){let n=r.to.dist(e);if(i+n>t)return e.shiftTowards(r.to,t-i);i+=n}else if("curve"===r.type){let n=new l({x:e.x,y:e.y},{x:r.cp1.x,y:r.cp1.y},{x:r.cp2.x,y:r.cp2.y},{x:r.to.x,y:r.to.y}),s=n.length();if(i+s>t)return g(t-i,n);i+=s}e=r.to}throw new Error("Ran out of path to shift along")},c.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},c.prototype.bbox=function(){let t,e=[];for(let i in this.ops){let n=this.ops[i];"line"===n.type?e.push(m({from:t,to:n.to})):"curve"===n.type&&e.push(v(new l({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}))),n.to&&(t=n.to)}return function(t){let e=1/0,i=-1/0,r=1/0,s=-1/0;for(let n of t)n.topLeft.x<e&&(e=n.topLeft.x),n.topLeft.y<r&&(r=n.topLeft.y),n.bottomRight.x>i&&(i=n.bottomRight.x),n.bottomRight.y>s&&(s=n.bottomRight.y);return{topLeft:new n(e,r),bottomRight:new n(i,s)}}(e)},c.prototype.reverse=function(){let t,e=[],i=!1;for(let n in this.ops){let r=this.ops[n];"line"===r.type?r.to.sitsOn(t)||e.push((new c).move(r.to).line(t)):"curve"===r.type?e.push((new c).move(r.to).curve(r.cp2,r.cp1,t)):"close"===r.type&&(i=!0),r.to&&(t=r.to)}let n=(new c).move(t);for(let t of e.reverse())n.ops.push(t.ops[1]);return i&&n.close(),n},c.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new n(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new n(this.topLeft.x,this.bottomRight.y);{let i=t+"Op";if("move"===this[i].type)return this[i].to;if("line"===this[i].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[i].type){return j((e=this[i],new l({x:e.from.x,y:e.from.y},{x:e.cp1.x,y:e.cp1.y},{x:e.cp2.x,y:e.cp2.y},{x:e.to.x,y:e.to.y})),t)}}var e},c.prototype.divide=function(){let t,e,i=[];for(let n in this.ops){let r=this.ops[n];"move"===r.type?e=r.to:"line"===r.type?r.to.sitsRoughlyOn(t)||i.push((new c).move(t).line(r.to)):"curve"===r.type?i.push((new c).move(t).curve(r.cp1,r.cp2,r.to)):"close"===r.type&&i.push((new c).move(t).line(e)),r.to&&(t=r.to)}return i},c.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},c.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},c.prototype.intersectsAxis=function(t=!1,e){if(!1===t)throw new Error("Path.intersects[X-Y] requires an value as parameter");let i=[],r="x"===e?new n(t,-1e5):new n(-1e4,t),s="x"===e?new n(t,1e5):new n(1e5,t);for(let t of this.divide())"line"===t.ops[1].type?w($(t.ops[0].to,t.ops[1].to,r,s),i):"curve"===t.ops[1].type&&w(R(r,s,t.ops[0].to,t.ops[1].cp1,t.ops[1].cp2,t.ops[1].to),i);return i},c.prototype.intersects=function(t){if(this===t)throw new Error("Calculating intersections between two identical paths is bad idea");let e=[];for(let i of this.divide())for(let n of t.divide())"line"===i.ops[1].type?"line"===n.ops[1].type?w($(i.ops[0].to,i.ops[1].to,n.ops[0].to,n.ops[1].to),e):"curve"===n.ops[1].type&&w(R(i.ops[0].to,i.ops[1].to,n.ops[0].to,n.ops[1].cp1,n.ops[1].cp2,n.ops[1].to),e):"curve"===i.ops[1].type&&("line"===n.ops[1].type?w(R(n.ops[0].to,n.ops[1].to,i.ops[0].to,i.ops[1].cp1,i.ops[1].cp2,i.ops[1].to),e):"curve"===n.ops[1].type&&w(L(i.ops[0].to,i.ops[1].cp1,i.ops[1].cp2,i.ops[1].to,n.ops[0].to,n.ops[1].cp1,n.ops[1].cp2,n.ops[1].to),e));return e},c.prototype.split=function(t){let e=this.divide(),i=!1,r=!1;for(let s in e){let o=e[s];if("line"===o.ops[1].type)M(o.ops[0].to,o.ops[1].to,t)&&((i=e.slice(0,s)).push((new c).move(o.ops[0].to).line(t)),s++,(r=e.slice(s)).unshift((new c).move(t).line(o.ops[1].to)));else if("curve"===o.ops[1].type){let h=k(o.ops[0].to,o.ops[1].cp1,o.ops[1].cp2,o.ops[1].to,t);if(!1!==h){let t=new l({x:o.ops[0].to.x,y:o.ops[0].to.y},{x:o.ops[1].cp1.x,y:o.ops[1].cp1.y},{x:o.ops[1].cp2.x,y:o.ops[1].cp2.y},{x:o.ops[1].to.x,y:o.ops[1].to.y}).split(h);(i=e.slice(0,s)).push((new c).move(new n(t.left.points[0].x,t.left.points[0].y)).curve(new n(t.left.points[1].x,t.left.points[1].y),new n(t.left.points[2].x,t.left.points[2].y),new n(t.left.points[3].x,t.left.points[3].y))),s++,(r=e.slice(s)).unshift((new c).move(new n(t.right.points[0].x,t.right.points[0].y)).curve(new n(t.right.points[1].x,t.right.points[1].y),new n(t.right.points[2].x,t.right.points[2].y),new n(t.right.points[3].x,t.right.points[3].y)))}}}return i&&(i=d(i)),r&&(r=d(r)),[i,r]},c.prototype.trim=function(){let t=this.divide();for(let e in t){let i=parseInt(e)+2,r=parseInt(t.length)-1;for(let s=i;s<r;s++){let i=t[e].intersects(t[s]);if(i.length>0){let r,o=i.pop(),h=t.slice(0,e),p=t.slice(parseInt(s)+1),u=new c,a=!0;for(let i of[e,s]){let e=t[i].ops;if("line"===e[1].type)u.line(o);else if("curve"===e[1].type){let t,i=new l({x:e[0].to.x,y:e[0].to.y},{x:e[1].cp1.x,y:e[1].cp1.y},{x:e[1].cp2.x,y:e[1].cp2.y},{x:e[1].to.x,y:e[1].to.y}),r=k(e[0].to,e[1].cp1,e[1].cp2,e[1].to,o),s=i.split(r);t=a?s.left:s.right,u.curve(new n(t.points[1].x,t.points[1].y),new n(t.points[2].x,t.points[2].y),new n(t.points[3].x,t.points[3].y))}a=!1}return r=h.length>0?d(h).join(u):u,p.length>0&&(r=r.join(d(p))),r.trim()}}}return this},c.prototype.translate=function(t,e){let i=this.clone();for(let n of i.ops)"close"!==n.type&&(n.to=n.to.translate(t,e)),"curve"===n.type&&(n.cp1=n.cp1.translate(t,e),n.cp2=n.cp2.translate(t,e));return i};var I=Object.freeze({capitalize:b,macroName:z,beamsIntersect:O,linesIntersect:$,pointOnBeam:_,pointOnLine:M,pointOnCurve:k,splitCurve:function(t,e,i,n,r){let[s,o]=(new c).move(t).curve(e,i,n).split(r);return[{start:s.ops[0].to,cp1:s.ops[1].cp1,cp2:s.ops[1].cp2,end:s.ops[1].to},{start:o.ops[0].to,cp1:o.ops[1].cp1,cp2:o.ops[1].cp2,end:o.ops[1].to}]},beamIntersectsX:function(t,e,i){return t.x!==e.x&&O(t,e,new n(i,-10),new n(i,10))},beamIntersectsY:function(t,e,i){return t.y!==e.y&&O(t,e,new n(-10,i),new n(10,i))},units:P,lineIntersectsCurve:R,curveIntersectsX:function(t,e,i,r,s){return R(new n(s,-1e4),new n(s,1e4),t,e,i,r)},curveIntersectsY:function(t,e,i,r,s){return R(new n(-1e4,s),new n(1e4,s),t,e,i,r)},curvesIntersect:L,circlesIntersect:function(t,e,i,r,s="x"){let o=t.dx(i),h=t.dy(i),p=t.dist(i);if(p>parseFloat(e)+parseFloat(r))return!1;if(p<parseFloat(r)-parseFloat(e))return!1;if(0===p&&e===r)return!1;let u=(Math.pow(e,2)-Math.pow(r,2)+Math.pow(p,2))/(2*p),a=Math.sqrt(Math.pow(e,2)-Math.pow(u,2)),f=t.x+u*o/p,l=t.y+u*h/p,c=new n(f+a*h/p,l-a*o/p),y=new n(f-a*h/p,l+a*o/p);return"x"===s&&c.x<=y.x||"y"===s&&c.y<=y.y?[c,y]:[y,c]},beamIntersectsCircle:S,lineIntersectsCircle:function(t,e,i,n,r="x"){let s=S(t,e,i,n,r);if(!1===s)return!1;if(1===s.length)return!!M(i,n,s[0])&&s;{let t=s[0],e=s[1];if(!M(i,n,t,5)&&!M(i,n,e,5))return!1;if(M(i,n,t,5)&&M(i,n,e,5))return"x"===r&&t.x<=e.x||"y"===r&&t.y<=e.y?[t,e]:[e,t];if(M(i,n,t,5))return[t];if(M(i,n,e,5))return[e]}},curveEdge:j,stretchToScale:function(t){return 1/(1+parseFloat(t))},round:A,sampleStyle:E,deg2rad:function(t){return t*(Math.PI/180)}});function T(t,e){return this.def=t,this.anchor=e,this.attributes=new i,this}function C(){return{preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]}}function D(){return this.attributes=new i,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=I,this.Point=n,this.Path=c,this.Snippet=T,this.hooks=new C,this}T.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},T.prototype.clone=function(){let t=new T(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t},D.prototype.macroClosure=function(t){let e=this;return function(t,i){let n=z(t);"function"==typeof e[n]?e[n](i):e.debug({type:"warning",label:"🚨 Macro not found",msg:`Macro ${t} is not registered`})}},D.prototype.debugClosure=function(){let t=this;return function(e){t.debug(e)}},D.prototype.runHooks=function(t,e=!1){!1===e&&(e=this);let i=this.hooks[t];if(i&&i.length>0)for(let t of i)t.method(e,t.data)},D.prototype.debug=function(t){this.runHooks("debug",t)},D.prototype.getId=function(){return this.freeId+=1,""+this.freeId},D.prototype.unitsClosure=function(t){let e=this;return function(t){return P(t,e.context.settings.units)}},D.prototype.boundary=function(){if(this.topLeft)return this;let t=new n(1/0,1/0),e=new n(-1/0,-1/0);for(let i in this.paths){let n=this.paths[i].boundary();n.render&&(n.topLeft.x<t.x&&(t.x=n.topLeft.x),n.topLeft.y<t.y&&(t.y=n.topLeft.y),n.bottomRight.x>e.x&&(e.x=n.bottomRight.x),n.bottomRight.y>e.y&&(e.y=n.bottomRight.y))}for(let i in this.points){let n=this.points[i],r=n.attributes.get("data-circle");r&&(r=parseFloat(r),n.x-r<t.x&&(t.x=n.x-r),n.y-r<t.y&&(t.y=n.y-r),n.x+r>e.x&&(e.x=n.x+r),n.y+r>e.y&&(e.y=n.y+r))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),e.x===-1/0&&(e.x=0),e.y===-1/0&&(e.y=0);let i=this.context.settings.margin;return this.context.settings.paperless&&i<10&&(i=10),this.topLeft=new n(t.x-i,t.y-i),this.bottomRight=new n(e.x+i,e.y+i),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},D.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform",`translate(${-1*this.topLeft.x}, ${-1*this.topLeft.y})`),this))},D.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},D.prototype.inject=function(t){for(let e of["points","paths","snippets"])for(let i in t[e])void 0===this[e][i]&&(this[e][i]=t[e][i].clone());return this},D.prototype.units=function(t){return P(t,this.context.settings.units)},D.prototype.shorthand=function(){let t=!!this.context.settings.complete,e=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:I,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:e,debug:this.debugClosure()}};var N="0.31.0";function H(t){this.openGroups=[],this.layout={},this.freeId=0,this.body="",this.style="",this.script="",this.defs="",this.pattern=t,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new i,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",t.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",N)}H.prototype.runHooks=function(t,e=!1){!1===e&&(e=this);let i=this.hooks[t];if(i.length>0)for(let t of i)t.method(e,t.data)},H.prototype.insertText=function(t){if(this.hooks.insertText.length>0)for(let e of this.hooks.insertText)t=e.method(this.pattern.settings.locale,t,e.data);return t},H.prototype.debug=function(){},H.prototype.render=function(t){this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox",`0 0 ${t.width} ${t.height}`),this.head=this.renderHead(),this.tail=this.renderTail(),this.svg="",this.layout={};for(let e in t.parts){let i=t.parts[e];if(i.render&&t.needs(e)){let t=this.renderPart(i);this.layout[e]={svg:t,transform:i.attributes.getAsArray("transform")},this.svg+=this.openGroup(`${this.idPrefix}part-${e}`,i.attributes),this.svg+=t,this.svg+=this.closeGroup()}}return this.svg=this.prefix+this.renderSvgTag()+this.head+this.svg+this.tail,this.runHooks("postRender"),this.svg},H.prototype.renderHead=function(){let t=this.renderStyle();return t+=this.renderScript(),t+=this.renderDefs(),t+=this.openGroup(this.idPrefix+"container")},H.prototype.renderTail=function(){let t="";return t+=this.closeGroup(),t+=this.nl()+"</svg>"},H.prototype.renderSvgTag=function(){let t="<svg";return this.indent(),t+=this.nl()+this.attributes.render(),this.outdent(),t+=this.nl()+">"+this.nl()},H.prototype.renderStyle=function(){let t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},H.prototype.renderScript=function(){let t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},H.prototype.renderDefs=function(){let t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},H.prototype.renderPart=function(t){let e="";for(let i in t.paths){let n=t.paths[i];n.render&&(e+=this.renderPath(n))}for(let i in t.points)t.points[i].attributes.get("data-text")&&(e+=this.renderText(t.points[i])),t.points[i].attributes.get("data-circle")&&(e+=this.renderCircle(t.points[i]));for(let i in t.snippets){let n=t.snippets[i];e+=this.renderSnippet(n,t)}return e},H.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),`${this.nl()}<path ${t.attributes.render()} />${this.renderPathText(t)}`},H.prototype.renderPathText=function(t){let e=t.attributes.get("data-text");if(!e)return"";this.text=this.insertText(e);let i=t.attributes.renderIfPrefixIs("data-text-"),n="",r=t.attributes.get("data-text-class");r&&r.indexOf("center")>-1?n=' startOffset="50%" ':r&&r.indexOf("right")>-1&&(n=' startOffset="100%" ');let s=this.nl()+"<text>";return this.indent(),s+=`<textPath xlink:href="#${t.attributes.get("id")}" ${n}><tspan ${i}>${this.text}</tspan></textPath>`,this.outdent(),s+=this.nl()+"</text>"},H.prototype.renderText=function(t){let e=t.attributes.getAsArray("data-text");if(!1!==e){let t="";for(let i of e)this.text=this.insertText(i),t+=this.text+" ";this.text=this.insertText(t)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);let i=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");let n=`${this.nl()}<text ${t.attributes.renderIfPrefixIs("data-text-")}>`;if(this.indent(),-1!==this.text.indexOf("\n")){let e=this.text.split("\n");n+=`<tspan>${e.shift()}</tspan>`;for(let r of e)n+=`<tspan x="${t.x}" dy="${i}">${r}</tspan>`}else n+=`<tspan>${this.text}</tspan>`;return this.outdent(),n+=this.nl()+"</text>"},H.prototype.renderCircle=function(t){return`<circle\n    cx="${t.x}"\n    cy="${t.y}"\n    r="${t.attributes.get("data-circle")}"\n    ${t.attributes.renderIfPrefixIs("data-circle-")}\n  ></circle>`},H.prototype.renderSnippet=function(t,e){let i=t.anchor.x,n=t.anchor.y,r=t.attributes.get("data-scale");r&&(t.attributes.add("transform",`translate(${i}, ${n})`),t.attributes.add("transform",`scale(${r})`),t.attributes.add("transform",`translate(${-1*i}, ${-1*n})`));let s=t.attributes.get("data-rotate");s&&t.attributes.add("transform",`rotate(${s}, ${i}, ${n})`);let o=this.nl();return o+=`<use x="${i}" y="${n}" `,o+=`xlink:href="#${t.def}" ${t.attributes.render()}>`,o+="</use>"},H.prototype.openGroup=function(t,e=!1){let i=this.nl()+this.nl();return i+=`\x3c!-- Start of group #${t} --\x3e`,i+=this.nl(),i+=`<g id="${t}"`,e&&(i+=` ${e.render()}`),i+=">",this.indent(),this.openGroups.push(t),i},H.prototype.closeGroup=function(){return this.outdent(),`${this.nl()}</g>${this.nl()}\x3c!-- end of group #${this.openGroups.pop()} --\x3e`},H.prototype.nl=function(){return"\n"+this.tab()},H.prototype.tab=function(){let t="";for(let e=0;e<this.tabs;e++)t+="  ";return t},H.prototype.indent=function(){this.tabs+=1},H.prototype.outdent=function(){this.tabs-=1},H.prototype.getId=function(){return this.freeId+=1,""+this.freeId};var F=function(){};F.prototype={fit:function(t){var e,i,n,r,s=t.length,o=s>0?t[0].width:0,h=s>0?t[0].height:0;for(this.root={x:0,y:0,width:o,height:h},e=0;e<s;e++)n=t[e],(i=this.findNode(this.root,n.width,n.height))?(r=this.splitNode(i,n.width,n.height),n.x=r.x,n.y=r.y):(r=this.growNode(n.width,n.height),n.x=r.x,n.y=r.y)},findNode:function(t,e,i){return t.used?this.findNode(t.right,e,i)||this.findNode(t.down,e,i):e<=t.width&&i<=t.height?t:null},splitNode:function(t,e,i){return t.used=!0,t.down={x:t.x,y:t.y+i,width:t.width,height:t.height-i},t.right={x:t.x+e,y:t.y,width:t.width-e,height:i},t},growNode:function(t,e){var i=t<=this.root.width,n=e<=this.root.height,r=n&&this.root.height>=this.root.width+t,s=i&&this.root.width>=this.root.height+e;return r?this.growRight(t,e):s?this.growDown(t,e):n?this.growRight(t,e):i?this.growDown(t,e):null},growRight:function(t,e){var i;return this.root={used:!0,x:0,y:0,width:this.root.width+t,height:this.root.height,down:this.root,right:{x:this.root.width,y:0,width:t,height:this.root.height}},(i=this.findNode(this.root,t,e))?this.splitNode(i,t,e):null},growDown:function(t,e){var i;return this.root={used:!0,x:0,y:0,width:this.root.width,height:this.root.height+e,down:{x:0,y:this.root.height,width:this.root.width,height:e},right:this.root},(i=this.findNode(this.root,t,e))?this.splitNode(i,t,e):null}};var G=F;function q(){this.data=new Map}function U(t={options:{}}){this.config=t,this.width=0,this.height=0,this.is="",this.store=new q,this.parts={},this.hooks=new C,this.Point=n,this.Path=c,this.Snippet=T,this.Attributes=i,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,layout:!0,options:{}},void 0===this.config.inject&&(this.config.inject=[]),void 0===this.config.dependencies&&(this.config.dependencies={}),void 0===this.config.hide&&(this.config.hide=[]),this.config.resolvedDependencies=this.resolveDependencies(this.config.dependencies),this.config.draftOrder=this.draftOrder(this.config.resolvedDependencies);for(let e in t.options){let i=t.options[e];if("object"==typeof i)if(void 0!==i.pct)this.settings.options[e]=i.pct/100;else if(void 0!==i.mm)this.settings.options[e]=i.mm;else if(void 0!==i.deg)this.settings.options[e]=i.deg;else if(void 0!==i.count)this.settings.options[e]=i.count;else if(void 0!==i.bool)this.settings.options[e]=i.bool;else{if(void 0===i.dflt)throw new Error("Unknown option type: "+JSON.stringify(i));this.settings.options[e]=i.dflt}else this.settings.options[e]=i}this.macros={};const e={parts:this.parts,config:this.config,settings:this.settings,store:this.store,macros:this.macros};this.Part=function(){let t=new D;t.context=e;for(let i in e.macros)t[z(i)]=e.macros[i];return t}}return q.prototype.set=function(t,e){this.data.set(t,e)},q.prototype.setIfUnset=function(t,e){this.data.has(t)||this.data.set(t,e)},q.prototype.get=function(t){return this.data.get(t)},U.prototype.apply=function(t){if("object"!=typeof t)return this;for(let i of Object.keys(t))if(Array.isArray(t[i]))if(Array.isArray(this.settings[i]))for(let e of t[i])this.settings[i].push(e);else this.settings[i]=t[i];else"object"==typeof t[i]?this.settings[i]=e({},this.settings[i],t[i]):this.settings[i]=t[i];return this},U.prototype.runHooks=function(t,e=!1){!1===e&&(e=this);let i=this.hooks[t];if(i.length>0)for(let t of i)t.method(e,t.data)},U.prototype.draft=function(){"sample"!==this.is&&(this.is="draft"),this.runHooks("preDraft");for(let t of this.config.draftOrder)if(this.parts[t]=new this.Part,"string"==typeof this.config.inject[t]&&this.parts[t].inject(this.parts[this.config.inject[t]]),this.needs(t)){let e="draft"+b(t);if("function"!=typeof this[e])throw new Error('Method "'+e+'" on pattern object is not callable');if(this.parts[t]=this[e](this.parts[t]),void 0===this.parts[t])throw new Error("Result of "+e+"() was undefined. Did you forget to return the Part object?");this.parts[t].render=this.wants(t)}return this.runHooks("postDraft"),this},U.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},U.prototype.sampleParts=function(){let t={};this.settings.complete=!1,this.settings.paperless=!1,this.draft();for(let e in this.parts)t[e]=new this.Part,t[e].render=this.parts[e].render;return t},U.prototype.sampleRun=function(t,e,i,n,r=!1){this.draft();for(let s in this.parts){let o=0,h=0;this.parts[s].points.anchor&&(void 0===e[s]?e[s]=this.parts[s].points.anchor:e[s].sitsOn(this.parts[s].points.anchor)||(o=this.parts[s].points.anchor.dx(e[s]),h=this.parts[s].points.anchor.dy(e[s])));for(let e in this.parts[s].paths)t[s].paths[e+"_"+i]=this.parts[s].paths[e].clone().attr("style",E(i,n)),this.parts[s].points.anchor&&(t[s].paths[e+"_"+i]=t[s].paths[e+"_"+i].translate(o,h)),!1!==r&&t[s].paths[e+"_"+i].attributes.add("class",r)}},U.prototype.sampleOption=function(t){let e,i;this.is="sample",this.runHooks("preSample");let n=1,r={},s=this.sampleParts(),o=this.config.options[t];if("object"==typeof o.list)return this.sampleListOption(t);if(void 0===o.min||void 0===o.max){o={min:.9*o,max:1.1*o}}void 0!==o.pct&&(n=100),i=o.min/n,e=(o.max/n-i)/9;for(let n=1;n<11;n++)this.settings.options[t]=i,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling option ${t} with value ${A(i)}`}),this.sampleRun(s,r,n,10),i+=e;return this.parts=s,this.runHooks("postSample"),this},U.prototype.sampleListOption=function(t){let e=this.sampleParts(),i=this.config.options[t],n={},r=1,s=i.list.length;for(let o of i.list)this.settings.options[t]=o,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling option ${t} with value ${A(o)}`}),this.sampleRun(e,n,r,s),r++;return this.parts=e,this},U.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");let e={},i=this.sampleParts(),n=this.settings.measurements[t];if(void 0===n)throw new Error("Cannot sample a measurement that is undefined: "+t);let r=n/50;n*=.9;for(let s=1;s<11;s++)this.settings.measurements[t]=n,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling option ${t} with value ${A(n)}`}),this.sampleRun(i,e,s,10),n+=r;return this.parts=i,this.runHooks("postSample"),this},U.prototype.sampleModels=function(t,e=!1){this.is="sample",this.runHooks("preSample");let i={},n=this.sampleParts(),r=0,s=Object.keys(t).length;for(let o in t){r++,this.settings.measurements=t[o],this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling model ${o}`});let h=o===e?"sample-focus":"";this.sampleRun(n,i,r,s,h)}return this.parts=n,this.runHooks("postSample"),this},U.prototype.debug=function(t){this.runHooks("debug",t)},U.prototype.render=function(){return this.svg=new H(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},U.prototype.on=function(t,e,i){this.hooks[t].push({method:e,data:i})},U.prototype.use=function(t,e=!1){return this.debug({type:"success",label:"🔌 Plugin loaded",msg:`${t.name} v${t.version}`}),t.hooks&&this.loadPluginHooks(t,e),t.macros&&this.loadPluginMacros(t),this},U.prototype.loadPluginHooks=function(t,e){for(let i of Object.keys(this.hooks))if("function"==typeof t.hooks[i])this.on(i,t.hooks[i],e);else if(Array.isArray(t.hooks[i]))for(let n of t.hooks[i])this.on(i,n,e)},U.prototype.loadPluginMacros=function(t){for(let e in t.macros)"function"==typeof t.macros[e]&&this.macro(e,t.macros[e])},U.prototype.macro=function(t,e){this.macros[t]=e},U.prototype.pack=function(){let t=[];for(let e in this.parts){let i=this.parts[e];if(i.attributes.remove("transform"),i.render&&this.needs(e)){i.stack();let n=i.bottomRight.x-i.topLeft.x,r=i.bottomRight.y-i.topLeft.y;!0===this.settings.layout?t.push({id:e,width:n,height:r}):(this.width<n&&(this.width=n),this.height<r&&(this.height=r))}}if(!0===this.settings.layout){let e=function(t,e){e=e||{};var i=new G,n=e.inPlace||!1,r=t.map(function(t){return n?t:{width:t.width,height:t.height,item:t}});r=r.sort(function(t,e){return e.width*e.height-t.width*t.height}),i.fit(r);var s={width:r.reduce(function(t,e){return Math.max(t,e.x+e.width)},0),height:r.reduce(function(t,e){return Math.max(t,e.y+e.height)},0)};return n||(s.items=r),s}(t,{inPlace:!0});for(let e of t){let t=this.parts[e.id];0===e.x&&0===e.y||t.attr("transform",`translate (${e.x}, ${e.y})`)}this.width=e.width,this.height=e.height}else if("object"==typeof this.settings.layout){this.width=this.settings.layout.width,this.height=this.settings.layout.height;for(let t of Object.keys(this.settings.layout.parts)){let e=this.settings.layout.parts[t];"object"==typeof e.move&&this.parts[t].attributes.set("transform","translate("+e.move.x+", "+e.move.y+")");let i=this.parts[t].topLeft.shiftFractionTowards(this.parts[t].bottomRight,.5),n={x:0,y:0};if(e.flipX){let e=n.x-i.x,r=`translate(${-1*i.x}, ${-1*i.y})`;r+=" scale(-1, 1)",r+=` translate(${-1*i.x+2*e}, ${i.y})`,this.parts[t].attributes.add("transform",r)}if(e.flipY){let e=n.y-i.y,r=`translate(${-1*i.x}, ${-1*i.y})`;r+=" scale(1, -1)",r+=` translate(${i.x}, ${-1*i.y+2*e})`,this.parts[t].attributes.add("transform",r)}if(e.rotate){let r=`rotate(${e.rotate}, ${i.x-n.x}, ${i.y-n.y})`;this.parts[t].attributes.add("transform",r)}}}return this},U.prototype.draftOrder=function(t=this.resolveDependencies()){let e=[],i={};return Object.keys(t).forEach(function n(r,s){Array.isArray(s)||(s=[]),s.push(r),i[r]=!0,void 0!==t[r]&&t[r].forEach(function(t){i[t]||n(t,s.slice(0))}),e.indexOf(r)<0&&e.push(r)}),e},U.prototype.resolveDependency=function(t,e,i=this.config.dependencies,n=[]){if(void 0===t[e]&&(t[e]=!0),"string"==typeof i[e])return n.push(i[e]),this.resolveDependency(t,i[e],i,n);if(Array.isArray(i[e])){if(0===i[e].length)return[];0===n.length&&(n=i[e]);for(let r of i[e])n.concat(this.resolveDependency(t,r,i,n))}return n},U.prototype.resolveDependencies=function(t=this.config.dependencies){if(Array.isArray(this.config.parts))for(let t of this.config.parts)void 0===this.config.dependencies[t]&&(this.config.dependencies[t]=[]);let e={},i={};for(let n of Object.keys(t))e[n]=this.resolveDependency(i,n,t);for(let t of Object.keys(i))void 0===e[t]&&(e[t]=[]);return e},U.prototype.needs=function(t){if(void 0===this.settings.only||!1===this.settings.only)return!0;if("string"==typeof this.settings.only){if(this.settings.only===t)return!0;if(Array.isArray(this.config.resolvedDependencies[this.settings.only]))for(let e of this.config.resolvedDependencies[this.settings.only])if(e===t)return!0}else if(Array.isArray(this.settings.only))for(let e of this.settings.only){if(e===t)return!0;for(let i of this.config.resolvedDependencies[e])if(i===t)return!0}return!1},U.prototype.isHidden=function(t){return!(!Array.isArray(this.config.hide)||-1===this.config.hide.indexOf(t))},U.prototype.wants=function(t){if(void 0===this.settings.only||!1===this.settings.only){if(this.isHidden(t))return!1}else{if("string"==typeof this.settings.only)return this.settings.only===t;if(Array.isArray(this.settings.only)){for(let e of this.settings.only)if(e===t)return!0;return!1}}return!0},{version:N,Design:function(t,e=!1){const i=function(i){if(U.call(this,t),Array.isArray(e))for(let t of e)this.use(t);else e&&this.use(e);return this.apply(i),this};return(i.prototype=Object.create(U.prototype)).constructor=i,i},Pattern:U,Point:n,Path:c,Snippet:T,utils:I,patterns:{},plugins:{}}}();
//# sourceMappingURL=browser.js.map
