/**
 * freesewing | v0.31.0
 * A library for creating made-to-measure sewing patterns
 * (c) 2019 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
"use strict";function _interopDefault(t){return t&&"object"==typeof t&&"default"in t?t.default:t}var Bezier=_interopDefault(require("bezier-js")),pack=_interopDefault(require("bin-pack"));function _defineProperty(t,e,i){return e in t?Object.defineProperty(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}function _objectSpread(t){for(var e=1;e<arguments.length;e++){var i=null!=arguments[e]?arguments[e]:{},s=Object.keys(i);"function"==typeof Object.getOwnPropertySymbols&&(s=s.concat(Object.getOwnPropertySymbols(i).filter(function(t){return Object.getOwnPropertyDescriptor(i,t).enumerable}))),s.forEach(function(e){_defineProperty(t,e,i[e])})}return t}function Attributes(){this.list={}}function Point(t,e){this.x=round(t),this.y=round(e),this.attributes=new Attributes}function Path(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new Attributes,this.ops=[]}function pathOffset(t,e){let i,s=[],o=!1;for(let n in t.ops){let r=t.ops[n];if("line"===r.type){let t=offsetLine(i,r.to,e);t&&s.push(t)}else if("curve"===r.type){let t,o;t=i.sitsRoughlyOn(r.cp1)?(new Path).move(i).curve(r.cp1,r.cp2,r.to).shiftAlong(2):r.cp1,o=r.cp2.sitsRoughlyOn(r.to)?(new Path).move(r.to).curve(r.cp2,r.cp1,i).shiftAlong(2):r.cp2;let n=new Bezier({x:i.x,y:i.y},{x:t.x,y:t.y},{x:o.x,y:o.y},{x:r.to.x,y:r.to.y});for(let t of n.offset(e))s.push(asPath(t))}else"close"===r.type&&(o=!0);r.to&&(i=r.to)}return joinPaths(s,o)}function offsetLine(t,e,i){if(t.x===e.x&&t.y===e.y)return!1;let s=t.angle(e)-90;return(new Path).move(t.shift(s,i)).line(e.shift(s,i))}function asPath(t){return(new Path).move(new Point(t.points[0].x,t.points[0].y)).curve(new Point(t.points[1].x,t.points[1].y),new Point(t.points[2].x,t.points[2].y),new Point(t.points[3].x,t.points[3].y))}function joinPaths(t,e=!1){let i,s=(new Path).move(t[0].ops[0].to);for(let e of t)for(let t of e.ops){if("curve"===t.type)s.curve(t.cp1,t.cp2,t.to);else{if("close"===t.type)throw new Error("Cannot join a closed paths with another");i&&!t.to.sitsRoughlyOn(i)&&s.line(t.to)}t.to&&(i=t.to)}return e&&s.close(),s}function shiftAlongBezier(t,e){let i,s,o,n,r=0;for(let p=0;p<=100;p++){if(o=p/100,s=new Point((s=e.get(o)).x,s.y),p>0){if(r+(n=s.dist(i))>t)return s;r+=n}i=s}}function lineBoundingBox(t){let e=t.from,i=t.to;return e.x===i.x?e.y<i.y?{topLeft:e,bottomRight:i}:{topLeft:i,bottomRight:e}:e.y===i.y?e.x<i.x?{topLeft:e,bottomRight:i}:{topLeft:i,bottomRight:e}:e.x<i.x?e.y<i.y?{topLeft:e,bottomRight:i}:{topLeft:new Point(e.x,i.y),bottomRight:new Point(i.x,e.y)}:e.x>i.x?e.y<i.y?{topLeft:new Point(i.x,e.y),bottomRight:new Point(e.x,i.y)}:{topLeft:new Point(i.x,i.y),bottomRight:new Point(e.x,e.y)}:void 0}function curveBoundingBox(t){let e=t.bbox();return{topLeft:new Point(e.x.min,e.y.min),bottomRight:new Point(e.x.max,e.y.max)}}function bbbbox(t){let e=1/0,i=-1/0,s=1/0,o=-1/0;for(let n of t)n.topLeft.x<e&&(e=n.topLeft.x),n.topLeft.y<s&&(s=n.topLeft.y),n.bottomRight.x>i&&(i=n.bottomRight.x),n.bottomRight.y>o&&(o=n.bottomRight.y);return{topLeft:new Point(e,s),bottomRight:new Point(i,o)}}function edgeCurveAsBezier(t){return new Bezier({x:t.from.x,y:t.from.y},{x:t.cp1.x,y:t.cp1.y},{x:t.cp2.x,y:t.cp2.y},{x:t.to.x,y:t.to.y})}function addIntersectionsToArray(t,e){if(t&&"object"==typeof t)if("number"==typeof t.x)e.push(t);else for(let i of t)e.push(i)}function capitalize(t){return t.charAt(0).toUpperCase()+t.slice(1)}function macroName(t){return`_macro_${t}`}function beamsIntersect(t,e,i,s){let o=t.slope(e),n=i.slope(s);if(o===n)return!1;if(t.x===e.x)return new Point(t.x,n*t.x+(i.y-n*i.x));if(i.x===s.x)return new Point(i.x,o*i.x+(t.y-o*t.x));{t.x>e.x&&(t=e.copy()),i.x>s.x&&(i=s.copy());let r=t.y-o*t.x,p=(i.y-n*i.x-r)/(o-n);return new Point(p,o*p+r)}}function linesIntersect(t,e,i,s){let o=beamsIntersect(t,e,i,s);if(!o)return!1;let n=t.dist(e),r=i.dist(s),p=t.dist(o)+o.dist(e),h=i.dist(o)+o.dist(s);return Math.round(n)==Math.round(p)&&Math.round(r)==Math.round(h)&&o}function pointOnBeam(t,e,i,s=1e6){if(t.sitsOn(i))return!0;if(e.sitsOn(i))return!0;let o=i.dx(t)*e.dy(t)-i.dy(t)*e.dx(t);return 0===Math.abs(Math.round(o*s)/s)}function pointOnLine(t,e,i,s=1e6){if(!pointOnBeam(t,e,i,s))return!1;let o=t.dist(e),n=t.dist(i)+i.dist(e);return Math.round(o)==Math.round(n)}function pointOnCurve(t,e,i,s,o){if(t.sitsOn(o))return!0;if(s.sitsOn(o))return!0;let n=new Bezier({x:t.x,y:t.y},{x:e.x,y:e.y},{x:i.x,y:i.y},{x:s.x,y:s.y}).intersects({p1:{x:o.x-1,y:o.y},p2:{x:o.x+1,y:o.y}});return n.length>0&&n.shift()}function splitCurve(t,e,i,s,o){let[n,r]=(new Path).move(t).curve(e,i,s).split(o);return[{start:n.ops[0].to,cp1:n.ops[1].cp1,cp2:n.ops[1].cp2,end:n.ops[1].to},{start:r.ops[0].to,cp1:r.ops[1].cp1,cp2:r.ops[1].cp2,end:r.ops[1].to}]}function beamIntersectsX(t,e,i){if(t.x===e.x)return!1;return beamsIntersect(t,e,new Point(i,-10),new Point(i,10))}function beamIntersectsY(t,e,i){if(t.y===e.y)return!1;return beamsIntersect(t,e,new Point(-10,i),new Point(10,i))}function units(t,e="metric"){return"imperial"===e?round(t/25.4)+'"':round(t/10)+"cm"}function lineIntersectsCurve(t,e,i,s,o,n){let r=[],p=new Bezier({x:i.x,y:i.y},{x:s.x,y:s.y},{x:o.x,y:o.y},{x:n.x,y:n.y}),h={p1:{x:t.x,y:t.y},p2:{x:e.x,y:e.y}};for(let t of p.intersects(h)){let e=p.get(t);r.push(new Point(e.x,e.y))}return 0!==r.length&&(1===r.length?r[0]:r)}function curveIntersectsX(t,e,i,s,o){return lineIntersectsCurve(new Point(o,-1e4),new Point(o,1e4),t,e,i,s)}function curveIntersectsY(t,e,i,s,o){return lineIntersectsCurve(new Point(-1e4,o),new Point(1e4,o),t,e,i,s)}function curvesIntersect(t,e,i,s,o,n,r,p){let h=[],a=new Bezier({x:t.x,y:t.y},{x:e.x,y:e.y},{x:i.x,y:i.y},{x:s.x,y:s.y}),u=new Bezier({x:o.x,y:o.y},{x:n.x,y:n.y},{x:r.x,y:r.y},{x:p.x,y:p.y});for(let t of a.intersects(u,.005)){let e=a.get(t.substr(0,t.indexOf("/")));h.push(new Point(e.x,e.y))}if(0===h.length)return!1;if(1===h.length)return h.shift();{let t=[];for(let e of h){let i=!1;for(let s of t)e.sitsRoughlyOn(s)&&(i=!0);i||t.push(e)}return t}}function circlesIntersect(t,e,i,s,o="x"){let n=t.dx(i),r=t.dy(i),p=t.dist(i);if(p>parseFloat(e)+parseFloat(s))return!1;if(p<parseFloat(s)-parseFloat(e))return!1;if(0===p&&e===s)return!1;let h=(Math.pow(e,2)-Math.pow(s,2)+Math.pow(p,2))/(2*p),a=Math.sqrt(Math.pow(e,2)-Math.pow(h,2)),u=t.x+h*n/p,l=t.y+h*r/p,f=new Point(u+a*r/p,l-a*n/p),c=new Point(u-a*r/p,l+a*n/p);return"x"===o&&f.x<=c.x||"y"===o&&f.y<=c.y?[f,c]:[c,f]}function beamIntersectsCircle(t,e,i,s,o="x"){let n=s.x-i.x,r=s.y-i.y,p=Math.pow(n,2)+Math.pow(r,2),h=2*(n*(i.x-t.x)+r*(i.y-t.y)),a=Math.pow(i.x-t.x,2)+Math.pow(i.y-t.y,2)-Math.pow(e,2),u=Math.pow(h,2)-4*p*a;if(p<=1e-7||u<0)return!1;if(0===u){let t=-1*h/(2*p);return[new Point(i.x+t*n,i.y+t*r)]}{let t=(-1*h+Math.sqrt(u))/(2*p),e=new Point(i.x+t*n,i.y+t*r);t=(-1*h-Math.sqrt(u))/(2*p);let s=new Point(i.x+t*n,i.y+t*r);return"x"===o&&e.x<=s.x||"y"===o&&e.y<=s.y?[e,s]:[s,e]}}function lineIntersectsCircle(t,e,i,s,o="x"){let n=beamIntersectsCircle(t,e,i,s,o);if(!1===n)return!1;if(1===n.length)return!!pointOnLine(i,s,n[0])&&n;{let t=n[0],e=n[1];if(!pointOnLine(i,s,t,5)&&!pointOnLine(i,s,e,5))return!1;if(pointOnLine(i,s,t,5)&&pointOnLine(i,s,e,5))return"x"===o&&t.x<=e.x||"y"===o&&t.y<=e.y?[t,e]:[e,t];if(pointOnLine(i,s,t,5))return[t];if(pointOnLine(i,s,e,5))return[e]}}function curveEdge(t,e,i=500){let s,o=1/0,n=1/0;"bottom"===e&&(n=-1/0),"right"===e&&(o=-1/0);for(let r=0;r<i;r++)s=t.get(r/i),("top"===e&&s.y<n||"bottom"===e&&s.y>n||"right"===e&&s.x>o||"left"===e&&s.x<o)&&(o=s.x,n=s.y);return new Point(o,n)}function stretchToScale(t){return 1/(1+parseFloat(t))}function round(t){return Math.round(100*t)/100}function sampleStyle(t,e){return`stroke: hsl(${330/e*(t-1)}, 100%, 35%);`}function deg2rad(t){return t*(Math.PI/180)}Attributes.prototype.add=function(t,e){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(e),this},Attributes.prototype.set=function(t,e){return this.list[t]=[e],this},Attributes.prototype.remove=function(t){return delete this.list[t],this},Attributes.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},Attributes.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},Attributes.prototype.render=function(){let t="";for(let e in this.list)t+=` ${e}="${this.list[e].join(" ")}"`;return t},Attributes.prototype.renderAsCss=function(){let t="";for(let e in this.list)t+=` ${e}:${this.list[e].join(" ")};`;return t},Attributes.prototype.renderIfPrefixIs=function(t=""){let e="",i=t.length;for(let s in this.list)s.substr(0,i)===t&&(e+=` ${s.substr(i)}="${this.list[s].join(" ")}"`);return e},Attributes.prototype.clone=function(){let t=new Attributes;return t.list=JSON.parse(JSON.stringify(this.list)),t},Point.prototype.rad2deg=function(t){return 57.29577951308232*t},Point.prototype.deg2rad=function(t){return t/57.29577951308232},Point.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},Point.prototype.dist=function(t){let e=this.x-t.x,i=this.y-t.y;return round(Math.sqrt(Math.pow(e,2)+Math.pow(i,2)))},Point.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},Point.prototype.dx=function(t){return t.x-this.x},Point.prototype.dy=function(t){return t.y-this.y},Point.prototype.angle=function(t){let e=Math.atan2(-1*this.dy(t),this.dx(t));for(;e<0;)e+=2*Math.PI;return this.rad2deg(e)},Point.prototype.rotate=function(t,e){let i=this.dist(e),s=this.angle(e);return new Point(e.x+i*Math.cos(this.deg2rad(s+t))*-1,e.y+i*Math.sin(this.deg2rad(s+t)))},Point.prototype.copy=function(){return new Point(this.x,this.y)},Point.prototype.flipX=function(t=!1){return!1===t||0===t.x?new Point(-1*this.x,this.y):new Point(t.x+this.dx(t),this.y)},Point.prototype.flipY=function(t=!1){return!1===t||0===t.y?new Point(this.x,-1*this.y):new Point(this.x,t.y+this.dy(t))},Point.prototype.shift=function(t,e){let i=this.copy();return i.x+=e,i.rotate(t,this)},Point.prototype.shiftTowards=function(t,e){return this.shift(this.angle(t),e)},Point.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},Point.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},Point.prototype.shiftFractionTowards=function(t,e){return this.shiftTowards(t,this.dist(t)*e)},Point.prototype.shiftOutwards=function(t,e){return this.shiftTowards(t,this.dist(t)+e)},Point.prototype.clone=function(){let t=new Point(this.x,this.y);return t.attributes=this.attributes.clone(),t},Point.prototype.translate=function(t,e){let i=this.copy();return i.x+=t,i.y+=e,i},Path.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},Path.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},Path.prototype.curve=function(t,e,i){return this.ops.push({type:"curve",cp1:t,cp2:e,to:i}),this},Path.prototype._curve=function(t,e){let i=this.ops.slice(-1).pop().to;return this.ops.push({type:"curve",cp1:i,cp2:t,to:e}),this},Path.prototype.curve_=function(t,e){let i=e.copy();return this.ops.push({type:"curve",cp1:t,cp2:i,to:e}),this},Path.prototype.close=function(){return this.ops.push({type:"close"}),this},Path.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},Path.prototype.asPathstring=function(){let t="";for(let e of this.ops)switch(e.type){case"move":t+=`M ${e.to.x},${e.to.y}`;break;case"line":t+=` L ${e.to.x},${e.to.y}`;break;case"curve":t+=` C ${e.cp1.x},${e.cp1.y} ${e.cp2.x},${e.cp2.y} ${e.to.x},${e.to.y}`;break;case"close":t+=" z"}return t},Path.prototype.offset=function(t){return pathOffset(this,t)},Path.prototype.length=function(){let t,e,i=0;for(let s in this.ops){let o=this.ops[s];"move"===o.type?e=o.to:"line"===o.type?i+=t.dist(o.to):"curve"===o.type?i+=new Bezier({x:t.x,y:t.y},{x:o.cp1.x,y:o.cp1.y},{x:o.cp2.x,y:o.cp2.y},{x:o.to.x,y:o.to.y}).length():"close"===o.type&&(i+=t.dist(e)),o.to&&(t=o.to)}return round(i)},Path.prototype.start=function(){return this.ops[0].to},Path.prototype.end=function(){let t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},Path.prototype.boundary=function(){if(this.topLeft)return this;let t,e=new Point(1/0,1/0),i=new Point(-1/0,-1/0),s=[];for(let o in this.ops){let n=this.ops[o];if("move"===n.type||"line"===n.type)n.to.x<e.x&&(e.x=n.to.x,s.leftOp=o),n.to.y<e.y&&(e.y=n.to.y,s.topOp=o),n.to.x>i.x&&(i.x=n.to.x,s.rightOp=o),n.to.y>i.y&&(i.y=n.to.y,s.bottomOp=o);else if("curve"===n.type){let r=new Bezier({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}).bbox();r.x.min<e.x&&(e.x=r.x.min,s.leftOp=o),r.y.min<e.y&&(e.y=r.y.min,s.topOp=o),r.x.max>i.x&&(i.x=r.x.max,s.rightOp=o),r.y.max>i.y&&(i.y=r.y.max,s.bottomOp=o)}n.to&&(t=n.to)}this.topLeft=e,this.bottomRight=i;for(let t of["top","left","bottom","right"]){let e=t+"Op";this[e]=this.ops[s[e]],this[e].from="move"===this[e].type?this[e].to:this.ops[s[e]-1].to}return this},Path.prototype.clone=function(){let t=new Path;t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[];for(let e in this.ops){let i=this.ops[e];t.ops[e]={type:i.type},"move"===i.type||"line"===i.type?t.ops[e].to=i.to.clone():"curve"===i.type&&(t.ops[e].to=i.to.clone(),t.ops[e].cp1=i.cp1.clone(),t.ops[e].cp2=i.cp2.clone())}return t},Path.prototype.join=function(t,e=!1){return joinPaths([this,t],e)},Path.prototype.shiftAlong=function(t){let e,i=0;for(let s in this.ops){let o=this.ops[s];if("line"===o.type){let s=o.to.dist(e);if(i+s>t)return e.shiftTowards(o.to,t-i);i+=s}else if("curve"===o.type){let s=new Bezier({x:e.x,y:e.y},{x:o.cp1.x,y:o.cp1.y},{x:o.cp2.x,y:o.cp2.y},{x:o.to.x,y:o.to.y}),n=s.length();if(i+n>t)return shiftAlongBezier(t-i,s);i+=n}e=o.to}throw new Error("Ran out of path to shift along")},Path.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},Path.prototype.bbox=function(){let t,e=[];for(let i in this.ops){let s=this.ops[i];"line"===s.type?e.push(lineBoundingBox({from:t,to:s.to})):"curve"===s.type&&e.push(curveBoundingBox(new Bezier({x:t.x,y:t.y},{x:s.cp1.x,y:s.cp1.y},{x:s.cp2.x,y:s.cp2.y},{x:s.to.x,y:s.to.y}))),s.to&&(t=s.to)}return bbbbox(e)},Path.prototype.reverse=function(){let t,e=[],i=!1;for(let s in this.ops){let o=this.ops[s];"line"===o.type?o.to.sitsOn(t)||e.push((new Path).move(o.to).line(t)):"curve"===o.type?e.push((new Path).move(o.to).curve(o.cp2,o.cp1,t)):"close"===o.type&&(i=!0),o.to&&(t=o.to)}let s=(new Path).move(t);for(let t of e.reverse())s.ops.push(t.ops[1]);return i&&s.close(),s},Path.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new Point(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new Point(this.topLeft.x,this.bottomRight.y);{let e=t+"Op";if("move"===this[e].type)return this[e].to;if("line"===this[e].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[e].type){return curveEdge(edgeCurveAsBezier(this[e]),t)}}},Path.prototype.divide=function(){let t,e,i=[];for(let s in this.ops){let o=this.ops[s];"move"===o.type?e=o.to:"line"===o.type?o.to.sitsRoughlyOn(t)||i.push((new Path).move(t).line(o.to)):"curve"===o.type?i.push((new Path).move(t).curve(o.cp1,o.cp2,o.to)):"close"===o.type&&i.push((new Path).move(t).line(e)),o.to&&(t=o.to)}return i},Path.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},Path.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},Path.prototype.intersectsAxis=function(t=!1,e){if(!1===t)throw new Error("Path.intersects[X-Y] requires an value as parameter");let i=[],s="x"===e?new Point(t,-1e5):new Point(-1e4,t),o="x"===e?new Point(t,1e5):new Point(1e5,t);for(let t of this.divide())"line"===t.ops[1].type?addIntersectionsToArray(linesIntersect(t.ops[0].to,t.ops[1].to,s,o),i):"curve"===t.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(s,o,t.ops[0].to,t.ops[1].cp1,t.ops[1].cp2,t.ops[1].to),i);return i},Path.prototype.intersects=function(t){if(this===t)throw new Error("Calculating intersections between two identical paths is bad idea");let e=[];for(let i of this.divide())for(let s of t.divide())"line"===i.ops[1].type?"line"===s.ops[1].type?addIntersectionsToArray(linesIntersect(i.ops[0].to,i.ops[1].to,s.ops[0].to,s.ops[1].to),e):"curve"===s.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(i.ops[0].to,i.ops[1].to,s.ops[0].to,s.ops[1].cp1,s.ops[1].cp2,s.ops[1].to),e):"curve"===i.ops[1].type&&("line"===s.ops[1].type?addIntersectionsToArray(lineIntersectsCurve(s.ops[0].to,s.ops[1].to,i.ops[0].to,i.ops[1].cp1,i.ops[1].cp2,i.ops[1].to),e):"curve"===s.ops[1].type&&addIntersectionsToArray(curvesIntersect(i.ops[0].to,i.ops[1].cp1,i.ops[1].cp2,i.ops[1].to,s.ops[0].to,s.ops[1].cp1,s.ops[1].cp2,s.ops[1].to),e));return e},Path.prototype.split=function(t){let e=this.divide(),i=!1,s=!1;for(let o in e){let n=e[o];if("line"===n.ops[1].type)pointOnLine(n.ops[0].to,n.ops[1].to,t)&&((i=e.slice(0,o)).push((new Path).move(n.ops[0].to).line(t)),o++,(s=e.slice(o)).unshift((new Path).move(t).line(n.ops[1].to)));else if("curve"===n.ops[1].type){let r=pointOnCurve(n.ops[0].to,n.ops[1].cp1,n.ops[1].cp2,n.ops[1].to,t);if(!1!==r){let t=new Bezier({x:n.ops[0].to.x,y:n.ops[0].to.y},{x:n.ops[1].cp1.x,y:n.ops[1].cp1.y},{x:n.ops[1].cp2.x,y:n.ops[1].cp2.y},{x:n.ops[1].to.x,y:n.ops[1].to.y}).split(r);(i=e.slice(0,o)).push((new Path).move(new Point(t.left.points[0].x,t.left.points[0].y)).curve(new Point(t.left.points[1].x,t.left.points[1].y),new Point(t.left.points[2].x,t.left.points[2].y),new Point(t.left.points[3].x,t.left.points[3].y))),o++,(s=e.slice(o)).unshift((new Path).move(new Point(t.right.points[0].x,t.right.points[0].y)).curve(new Point(t.right.points[1].x,t.right.points[1].y),new Point(t.right.points[2].x,t.right.points[2].y),new Point(t.right.points[3].x,t.right.points[3].y)))}}}return i&&(i=joinPaths(i)),s&&(s=joinPaths(s)),[i,s]},Path.prototype.trim=function(){let t=this.divide();for(let e in t){let i=parseInt(e)+2,s=parseInt(t.length)-1;for(let o=i;o<s;o++){let i=t[e].intersects(t[o]);if(i.length>0){let s,n=i.pop(),r=t.slice(0,e),p=t.slice(parseInt(o)+1),h=new Path,a=!0;for(let i of[e,o]){let e=t[i].ops;if("line"===e[1].type)h.line(n);else if("curve"===e[1].type){let t,i=new Bezier({x:e[0].to.x,y:e[0].to.y},{x:e[1].cp1.x,y:e[1].cp1.y},{x:e[1].cp2.x,y:e[1].cp2.y},{x:e[1].to.x,y:e[1].to.y}),s=pointOnCurve(e[0].to,e[1].cp1,e[1].cp2,e[1].to,n),o=i.split(s);t=a?o.left:o.right,h.curve(new Point(t.points[1].x,t.points[1].y),new Point(t.points[2].x,t.points[2].y),new Point(t.points[3].x,t.points[3].y))}a=!1}return s=r.length>0?joinPaths(r).join(h):h,p.length>0&&(s=s.join(joinPaths(p))),s.trim()}}}return this},Path.prototype.translate=function(t,e){let i=this.clone();for(let s of i.ops)"close"!==s.type&&(s.to=s.to.translate(t,e)),"curve"===s.type&&(s.cp1=s.cp1.translate(t,e),s.cp2=s.cp2.translate(t,e));return i};var utils=Object.freeze({capitalize:capitalize,macroName:macroName,beamsIntersect:beamsIntersect,linesIntersect:linesIntersect,pointOnBeam:pointOnBeam,pointOnLine:pointOnLine,pointOnCurve:pointOnCurve,splitCurve:splitCurve,beamIntersectsX:beamIntersectsX,beamIntersectsY:beamIntersectsY,units:units,lineIntersectsCurve:lineIntersectsCurve,curveIntersectsX:curveIntersectsX,curveIntersectsY:curveIntersectsY,curvesIntersect:curvesIntersect,circlesIntersect:circlesIntersect,beamIntersectsCircle:beamIntersectsCircle,lineIntersectsCircle:lineIntersectsCircle,curveEdge:curveEdge,stretchToScale:stretchToScale,round:round,sampleStyle:sampleStyle,deg2rad:deg2rad});function Snippet(t,e){return this.def=t,this.anchor=e,this.attributes=new Attributes,this}function Hooks(){return{preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]}}function Part(){return this.attributes=new Attributes,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=utils,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this.hooks=new Hooks,this}Snippet.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},Snippet.prototype.clone=function(){let t=new Snippet(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t},Part.prototype.macroClosure=function(t){let e=this;return function(t,i){let s=macroName(t);"function"==typeof e[s]?e[s](i):e.debug({type:"warning",label:"🚨 Macro not found",msg:`Macro ${t} is not registered`})}},Part.prototype.debugClosure=function(){let t=this;return function(e){t.debug(e)}},Part.prototype.runHooks=function(t,e=!1){!1===e&&(e=this);let i=this.hooks[t];if(i&&i.length>0)for(let t of i)t.method(e,t.data)},Part.prototype.debug=function(t){this.runHooks("debug",t)},Part.prototype.getId=function(){return this.freeId+=1,""+this.freeId},Part.prototype.unitsClosure=function(t){let e=this;return function(t){return units(t,e.context.settings.units)}},Part.prototype.boundary=function(){if(this.topLeft)return this;let t=new Point(1/0,1/0),e=new Point(-1/0,-1/0);for(let i in this.paths){let s=this.paths[i].boundary();s.render&&(s.topLeft.x<t.x&&(t.x=s.topLeft.x),s.topLeft.y<t.y&&(t.y=s.topLeft.y),s.bottomRight.x>e.x&&(e.x=s.bottomRight.x),s.bottomRight.y>e.y&&(e.y=s.bottomRight.y))}for(let i in this.points){let s=this.points[i],o=s.attributes.get("data-circle");o&&(o=parseFloat(o),s.x-o<t.x&&(t.x=s.x-o),s.y-o<t.y&&(t.y=s.y-o),s.x+o>e.x&&(e.x=s.x+o),s.y+o>e.y&&(e.y=s.y+o))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),e.x===-1/0&&(e.x=0),e.y===-1/0&&(e.y=0);let i=this.context.settings.margin;return this.context.settings.paperless&&i<10&&(i=10),this.topLeft=new Point(t.x-i,t.y-i),this.bottomRight=new Point(e.x+i,e.y+i),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},Part.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform",`translate(${-1*this.topLeft.x}, ${-1*this.topLeft.y})`),this))},Part.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},Part.prototype.inject=function(t){for(let e of["points","paths","snippets"])for(let i in t[e])void 0===this[e][i]&&(this[e][i]=t[e][i].clone());return this},Part.prototype.units=function(t){return units(t,this.context.settings.units)},Part.prototype.shorthand=function(){let t=!!this.context.settings.complete,e=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:utils,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:e,debug:this.debugClosure()}};var version="0.31.0";function Svg(t){this.openGroups=[],this.layout={},this.freeId=0,this.body="",this.style="",this.script="",this.defs="",this.pattern=t,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new Attributes,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",t.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",version)}function Store(){this.data=new Map}function Pattern(t={options:{}}){this.config=t,this.width=0,this.height=0,this.is="",this.store=new Store,this.parts={},this.hooks=new Hooks,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this.Attributes=Attributes,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,layout:!0,options:{}},void 0===this.config.inject&&(this.config.inject=[]),void 0===this.config.dependencies&&(this.config.dependencies={}),void 0===this.config.hide&&(this.config.hide=[]),this.config.resolvedDependencies=this.resolveDependencies(this.config.dependencies),this.config.draftOrder=this.draftOrder(this.config.resolvedDependencies);for(let e in t.options){let i=t.options[e];if("object"==typeof i)if(void 0!==i.pct)this.settings.options[e]=i.pct/100;else if(void 0!==i.mm)this.settings.options[e]=i.mm;else if(void 0!==i.deg)this.settings.options[e]=i.deg;else if(void 0!==i.count)this.settings.options[e]=i.count;else if(void 0!==i.bool)this.settings.options[e]=i.bool;else{if(void 0===i.dflt)throw new Error("Unknown option type: "+JSON.stringify(i));this.settings.options[e]=i.dflt}else this.settings.options[e]=i}this.macros={};const e={parts:this.parts,config:this.config,settings:this.settings,store:this.store,macros:this.macros};this.Part=function(){let t=new Part;t.context=e;for(let i in e.macros)t[macroName(i)]=e.macros[i];return t}}function Design(t,e=!1){const i=function(i){if(Pattern.call(this,t),Array.isArray(e))for(let t of e)this.use(t);else e&&this.use(e);return this.apply(i),this};return(i.prototype=Object.create(Pattern.prototype)).constructor=i,i}Svg.prototype.runHooks=function(t,e=!1){!1===e&&(e=this);let i=this.hooks[t];if(i.length>0)for(let t of i)t.method(e,t.data)},Svg.prototype.insertText=function(t){if(this.hooks.insertText.length>0)for(let e of this.hooks.insertText)t=e.method(this.pattern.settings.locale,t,e.data);return t},Svg.prototype.debug=function(){},Svg.prototype.render=function(t){this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox",`0 0 ${t.width} ${t.height}`),this.head=this.renderHead(),this.tail=this.renderTail(),this.svg="",this.layout={};for(let e in t.parts){let i=t.parts[e];if(i.render&&t.needs(e)){let t=this.renderPart(i);this.layout[e]={svg:t,transform:i.attributes.getAsArray("transform")},this.svg+=this.openGroup(`${this.idPrefix}part-${e}`,i.attributes),this.svg+=t,this.svg+=this.closeGroup()}}return this.svg=this.prefix+this.renderSvgTag()+this.head+this.svg+this.tail,this.runHooks("postRender"),this.svg},Svg.prototype.renderHead=function(){let t=this.renderStyle();return t+=this.renderScript(),t+=this.renderDefs(),t+=this.openGroup(this.idPrefix+"container")},Svg.prototype.renderTail=function(){let t="";return t+=this.closeGroup(),t+=this.nl()+"</svg>"},Svg.prototype.renderSvgTag=function(){let t="<svg";return this.indent(),t+=this.nl()+this.attributes.render(),this.outdent(),t+=this.nl()+">"+this.nl()},Svg.prototype.renderStyle=function(){let t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},Svg.prototype.renderScript=function(){let t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},Svg.prototype.renderDefs=function(){let t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},Svg.prototype.renderPart=function(t){let e="";for(let i in t.paths){let s=t.paths[i];s.render&&(e+=this.renderPath(s))}for(let i in t.points)t.points[i].attributes.get("data-text")&&(e+=this.renderText(t.points[i])),t.points[i].attributes.get("data-circle")&&(e+=this.renderCircle(t.points[i]));for(let i in t.snippets){let s=t.snippets[i];e+=this.renderSnippet(s,t)}return e},Svg.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),`${this.nl()}<path ${t.attributes.render()} />${this.renderPathText(t)}`},Svg.prototype.renderPathText=function(t){let e=t.attributes.get("data-text");if(!e)return"";this.text=this.insertText(e);let i=t.attributes.renderIfPrefixIs("data-text-"),s="",o=t.attributes.get("data-text-class");o&&o.indexOf("center")>-1?s=' startOffset="50%" ':o&&o.indexOf("right")>-1&&(s=' startOffset="100%" ');let n=this.nl()+"<text>";return this.indent(),n+=`<textPath xlink:href="#${t.attributes.get("id")}" ${s}><tspan ${i}>${this.text}</tspan></textPath>`,this.outdent(),n+=this.nl()+"</text>"},Svg.prototype.renderText=function(t){let e=t.attributes.getAsArray("data-text");if(!1!==e){let t="";for(let i of e)this.text=this.insertText(i),t+=this.text+" ";this.text=this.insertText(t)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);let i=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");let s=`${this.nl()}<text ${t.attributes.renderIfPrefixIs("data-text-")}>`;if(this.indent(),-1!==this.text.indexOf("\n")){let e=this.text.split("\n");s+=`<tspan>${e.shift()}</tspan>`;for(let o of e)s+=`<tspan x="${t.x}" dy="${i}">${o}</tspan>`}else s+=`<tspan>${this.text}</tspan>`;return this.outdent(),s+=this.nl()+"</text>"},Svg.prototype.renderCircle=function(t){return`<circle\n    cx="${t.x}"\n    cy="${t.y}"\n    r="${t.attributes.get("data-circle")}"\n    ${t.attributes.renderIfPrefixIs("data-circle-")}\n  ></circle>`},Svg.prototype.renderSnippet=function(t,e){let i=t.anchor.x,s=t.anchor.y,o=t.attributes.get("data-scale");o&&(t.attributes.add("transform",`translate(${i}, ${s})`),t.attributes.add("transform",`scale(${o})`),t.attributes.add("transform",`translate(${-1*i}, ${-1*s})`));let n=t.attributes.get("data-rotate");n&&t.attributes.add("transform",`rotate(${n}, ${i}, ${s})`);let r=this.nl();return r+=`<use x="${i}" y="${s}" `,r+=`xlink:href="#${t.def}" ${t.attributes.render()}>`,r+="</use>"},Svg.prototype.openGroup=function(t,e=!1){let i=this.nl()+this.nl();return i+=`\x3c!-- Start of group #${t} --\x3e`,i+=this.nl(),i+=`<g id="${t}"`,e&&(i+=` ${e.render()}`),i+=">",this.indent(),this.openGroups.push(t),i},Svg.prototype.closeGroup=function(){return this.outdent(),`${this.nl()}</g>${this.nl()}\x3c!-- end of group #${this.openGroups.pop()} --\x3e`},Svg.prototype.nl=function(){return"\n"+this.tab()},Svg.prototype.tab=function(){let t="";for(let e=0;e<this.tabs;e++)t+="  ";return t},Svg.prototype.indent=function(){this.tabs+=1},Svg.prototype.outdent=function(){this.tabs-=1},Svg.prototype.getId=function(){return this.freeId+=1,""+this.freeId},Store.prototype.set=function(t,e){this.data.set(t,e)},Store.prototype.setIfUnset=function(t,e){this.data.has(t)||this.data.set(t,e)},Store.prototype.get=function(t){return this.data.get(t)},Pattern.prototype.apply=function(t){if("object"!=typeof t)return this;for(let e of Object.keys(t))if(Array.isArray(t[e]))if(Array.isArray(this.settings[e]))for(let i of t[e])this.settings[e].push(i);else this.settings[e]=t[e];else"object"==typeof t[e]?this.settings[e]=_objectSpread({},this.settings[e],t[e]):this.settings[e]=t[e];return this},Pattern.prototype.runHooks=function(t,e=!1){!1===e&&(e=this);let i=this.hooks[t];if(i.length>0)for(let t of i)t.method(e,t.data)},Pattern.prototype.draft=function(){"sample"!==this.is&&(this.is="draft"),this.runHooks("preDraft");for(let t of this.config.draftOrder)if(this.parts[t]=new this.Part,"string"==typeof this.config.inject[t]&&this.parts[t].inject(this.parts[this.config.inject[t]]),this.needs(t)){let e="draft"+capitalize(t);if("function"!=typeof this[e])throw new Error('Method "'+e+'" on pattern object is not callable');if(this.parts[t]=this[e](this.parts[t]),void 0===this.parts[t])throw new Error("Result of "+e+"() was undefined. Did you forget to return the Part object?");this.parts[t].render=this.wants(t)}return this.runHooks("postDraft"),this},Pattern.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},Pattern.prototype.sampleParts=function(){let t={};this.settings.complete=!1,this.settings.paperless=!1,this.draft();for(let e in this.parts)t[e]=new this.Part,t[e].render=this.parts[e].render;return t},Pattern.prototype.sampleRun=function(t,e,i,s,o=!1){this.draft();for(let n in this.parts){let r=0,p=0;this.parts[n].points.anchor&&(void 0===e[n]?e[n]=this.parts[n].points.anchor:e[n].sitsOn(this.parts[n].points.anchor)||(r=this.parts[n].points.anchor.dx(e[n]),p=this.parts[n].points.anchor.dy(e[n])));for(let e in this.parts[n].paths)t[n].paths[e+"_"+i]=this.parts[n].paths[e].clone().attr("style",sampleStyle(i,s)),this.parts[n].points.anchor&&(t[n].paths[e+"_"+i]=t[n].paths[e+"_"+i].translate(r,p)),!1!==o&&t[n].paths[e+"_"+i].attributes.add("class",o)}},Pattern.prototype.sampleOption=function(t){let e,i;this.is="sample",this.runHooks("preSample");let s=1,o={},n=this.sampleParts(),r=this.config.options[t];if("object"==typeof r.list)return this.sampleListOption(t);if(void 0===r.min||void 0===r.max){r={min:.9*r,max:1.1*r}}void 0!==r.pct&&(s=100),i=r.min/s,e=(r.max/s-i)/9;for(let s=1;s<11;s++)this.settings.options[t]=i,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling option ${t} with value ${round(i)}`}),this.sampleRun(n,o,s,10),i+=e;return this.parts=n,this.runHooks("postSample"),this},Pattern.prototype.sampleListOption=function(t){let e=this.sampleParts(),i=this.config.options[t],s={},o=1,n=i.list.length;for(let r of i.list)this.settings.options[t]=r,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling option ${t} with value ${round(r)}`}),this.sampleRun(e,s,o,n),o++;return this.parts=e,this},Pattern.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");let e={},i=this.sampleParts(),s=this.settings.measurements[t];if(void 0===s)throw new Error("Cannot sample a measurement that is undefined: "+t);let o=s/50;s*=.9;for(let n=1;n<11;n++)this.settings.measurements[t]=s,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling option ${t} with value ${round(s)}`}),this.sampleRun(i,e,n,10),s+=o;return this.parts=i,this.runHooks("postSample"),this},Pattern.prototype.sampleModels=function(t,e=!1){this.is="sample",this.runHooks("preSample");let i={},s=this.sampleParts(),o=0,n=Object.keys(t).length;for(let r in t){o++,this.settings.measurements=t[r],this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling model ${r}`});let p=r===e?"sample-focus":"";this.sampleRun(s,i,o,n,p)}return this.parts=s,this.runHooks("postSample"),this},Pattern.prototype.debug=function(t){this.runHooks("debug",t)},Pattern.prototype.render=function(){return this.svg=new Svg(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},Pattern.prototype.on=function(t,e,i){this.hooks[t].push({method:e,data:i})},Pattern.prototype.use=function(t,e=!1){return this.debug({type:"success",label:"🔌 Plugin loaded",msg:`${t.name} v${t.version}`}),t.hooks&&this.loadPluginHooks(t,e),t.macros&&this.loadPluginMacros(t),this},Pattern.prototype.loadPluginHooks=function(t,e){for(let i of Object.keys(this.hooks))if("function"==typeof t.hooks[i])this.on(i,t.hooks[i],e);else if(Array.isArray(t.hooks[i]))for(let s of t.hooks[i])this.on(i,s,e)},Pattern.prototype.loadPluginMacros=function(t){for(let e in t.macros)"function"==typeof t.macros[e]&&this.macro(e,t.macros[e])},Pattern.prototype.macro=function(t,e){this.macros[t]=e},Pattern.prototype.pack=function(){let t=[];for(let e in this.parts){let i=this.parts[e];if(i.attributes.remove("transform"),i.render&&this.needs(e)){i.stack();let s=i.bottomRight.x-i.topLeft.x,o=i.bottomRight.y-i.topLeft.y;!0===this.settings.layout?t.push({id:e,width:s,height:o}):(this.width<s&&(this.width=s),this.height<o&&(this.height=o))}}if(!0===this.settings.layout){let e=pack(t,{inPlace:!0});for(let e of t){let t=this.parts[e.id];0===e.x&&0===e.y||t.attr("transform",`translate (${e.x}, ${e.y})`)}this.width=e.width,this.height=e.height}else if("object"==typeof this.settings.layout){this.width=this.settings.layout.width,this.height=this.settings.layout.height;for(let t of Object.keys(this.settings.layout.parts)){let e=this.settings.layout.parts[t];"object"==typeof e.move&&this.parts[t].attributes.set("transform","translate("+e.move.x+", "+e.move.y+")");let i=this.parts[t].topLeft.shiftFractionTowards(this.parts[t].bottomRight,.5),s={x:0,y:0};if(e.flipX){let e=s.x-i.x,o=`translate(${-1*i.x}, ${-1*i.y})`;o+=" scale(-1, 1)",o+=` translate(${-1*i.x+2*e}, ${i.y})`,this.parts[t].attributes.add("transform",o)}if(e.flipY){let e=s.y-i.y,o=`translate(${-1*i.x}, ${-1*i.y})`;o+=" scale(1, -1)",o+=` translate(${i.x}, ${-1*i.y+2*e})`,this.parts[t].attributes.add("transform",o)}if(e.rotate){let o=`rotate(${e.rotate}, ${i.x-s.x}, ${i.y-s.y})`;this.parts[t].attributes.add("transform",o)}}}return this},Pattern.prototype.draftOrder=function(t=this.resolveDependencies()){let e=[],i={};return Object.keys(t).forEach(function s(o,n){Array.isArray(n)||(n=[]),n.push(o),i[o]=!0,void 0!==t[o]&&t[o].forEach(function(t){i[t]||s(t,n.slice(0))}),e.indexOf(o)<0&&e.push(o)}),e},Pattern.prototype.resolveDependency=function(t,e,i=this.config.dependencies,s=[]){if(void 0===t[e]&&(t[e]=!0),"string"==typeof i[e])return s.push(i[e]),this.resolveDependency(t,i[e],i,s);if(Array.isArray(i[e])){if(0===i[e].length)return[];0===s.length&&(s=i[e]);for(let o of i[e])s.concat(this.resolveDependency(t,o,i,s))}return s},Pattern.prototype.resolveDependencies=function(t=this.config.dependencies){if(Array.isArray(this.config.parts))for(let t of this.config.parts)void 0===this.config.dependencies[t]&&(this.config.dependencies[t]=[]);let e={},i={};for(let s of Object.keys(t))e[s]=this.resolveDependency(i,s,t);for(let t of Object.keys(i))void 0===e[t]&&(e[t]=[]);return e},Pattern.prototype.needs=function(t){if(void 0===this.settings.only||!1===this.settings.only)return!0;if("string"==typeof this.settings.only){if(this.settings.only===t)return!0;if(Array.isArray(this.config.resolvedDependencies[this.settings.only]))for(let e of this.config.resolvedDependencies[this.settings.only])if(e===t)return!0}else if(Array.isArray(this.settings.only))for(let e of this.settings.only){if(e===t)return!0;for(let i of this.config.resolvedDependencies[e])if(i===t)return!0}return!1},Pattern.prototype.isHidden=function(t){return!(!Array.isArray(this.config.hide)||-1===this.config.hide.indexOf(t))},Pattern.prototype.wants=function(t){if(void 0===this.settings.only||!1===this.settings.only){if(this.isHidden(t))return!1}else{if("string"==typeof this.settings.only)return this.settings.only===t;if(Array.isArray(this.settings.only)){for(let e of this.settings.only)if(e===t)return!0;return!1}}return!0};var index={version:version,Design:Design,Pattern:Pattern,Point:Point,Path:Path,Snippet:Snippet,utils:utils,patterns:{},plugins:{}};module.exports=index;
//# sourceMappingURL=index.js.map
