/**
 * freesewing | v0.31.0
 * A library for creating made-to-measure sewing patterns
 * (c) 2019 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
function _defineProperty(t,e,i){return e in t?Object.defineProperty(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}function _objectSpread(t){for(var e=1;e<arguments.length;e++){var i=null!=arguments[e]?arguments[e]:{},n=Object.keys(i);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(i).filter(function(t){return Object.getOwnPropertyDescriptor(i,t).enumerable}))),n.forEach(function(e){_defineProperty(t,e,i[e])})}return t}function Attributes(){this.list={}}function Point(t,e){this.x=round(t),this.y=round(e),this.attributes=new Attributes}function createCommonjsModule(t,e){return t(e={exports:{}},e.exports),e.exports}Attributes.prototype.add=function(t,e){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(e),this},Attributes.prototype.set=function(t,e){return this.list[t]=[e],this},Attributes.prototype.remove=function(t){return delete this.list[t],this},Attributes.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},Attributes.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},Attributes.prototype.render=function(){let t="";for(let e in this.list)t+=` ${e}="${this.list[e].join(" ")}"`;return t},Attributes.prototype.renderAsCss=function(){let t="";for(let e in this.list)t+=` ${e}:${this.list[e].join(" ")};`;return t},Attributes.prototype.renderIfPrefixIs=function(t=""){let e="",i=t.length;for(let n in this.list)n.substr(0,i)===t&&(e+=` ${n.substr(i)}="${this.list[n].join(" ")}"`);return e},Attributes.prototype.clone=function(){let t=new Attributes;return t.list=JSON.parse(JSON.stringify(this.list)),t},Point.prototype.rad2deg=function(t){return 57.29577951308232*t},Point.prototype.deg2rad=function(t){return t/57.29577951308232},Point.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},Point.prototype.dist=function(t){let e=this.x-t.x,i=this.y-t.y;return round(Math.sqrt(Math.pow(e,2)+Math.pow(i,2)))},Point.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},Point.prototype.dx=function(t){return t.x-this.x},Point.prototype.dy=function(t){return t.y-this.y},Point.prototype.angle=function(t){let e=Math.atan2(-1*this.dy(t),this.dx(t));for(;e<0;)e+=2*Math.PI;return this.rad2deg(e)},Point.prototype.rotate=function(t,e){let i=this.dist(e),n=this.angle(e);return new Point(e.x+i*Math.cos(this.deg2rad(n+t))*-1,e.y+i*Math.sin(this.deg2rad(n+t)))},Point.prototype.copy=function(){return new Point(this.x,this.y)},Point.prototype.flipX=function(t=!1){return!1===t||0===t.x?new Point(-1*this.x,this.y):new Point(t.x+this.dx(t),this.y)},Point.prototype.flipY=function(t=!1){return!1===t||0===t.y?new Point(this.x,-1*this.y):new Point(this.x,t.y+this.dy(t))},Point.prototype.shift=function(t,e){let i=this.copy();return i.x+=e,i.rotate(t,this)},Point.prototype.shiftTowards=function(t,e){return this.shift(this.angle(t),e)},Point.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},Point.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},Point.prototype.shiftFractionTowards=function(t,e){return this.shiftTowards(t,this.dist(t)*e)},Point.prototype.shiftOutwards=function(t,e){return this.shiftTowards(t,this.dist(t)+e)},Point.prototype.clone=function(){let t=new Point(this.x,this.y);return t.attributes=this.attributes.clone(),t},Point.prototype.translate=function(t,e){let i=this.copy();return i.x+=t,i.y+=e,i};var utils=createCommonjsModule(function(t){var e,i,n,r,o,s,h,p,a,u,f,c,l,y,x;e=Math.abs,i=Math.cos,n=Math.sin,r=Math.acos,o=Math.atan2,s=Math.sqrt,h=Math.pow,p=function(t){return t<0?-h(-t,1/3):h(t,1/3)},a=Math.PI,u=2*a,f=a/2,c=Number.MAX_SAFE_INTEGER||9007199254740991,l=Number.MIN_SAFE_INTEGER||-9007199254740991,y={x:0,y:0,z:0},x={Tvalues:[-.06405689286260563,.06405689286260563,-.1911188674736163,.1911188674736163,-.3150426796961634,.3150426796961634,-.4337935076260451,.4337935076260451,-.5454214713888396,.5454214713888396,-.6480936519369755,.6480936519369755,-.7401241915785544,.7401241915785544,-.820001985973903,.820001985973903,-.8864155270044011,.8864155270044011,-.9382745520027328,.9382745520027328,-.9747285559713095,.9747285559713095,-.9951872199970213,.9951872199970213],Cvalues:[.12793819534675216,.12793819534675216,.1258374563468283,.1258374563468283,.12167047292780339,.12167047292780339,.1155056680537256,.1155056680537256,.10744427011596563,.10744427011596563,.09761865210411388,.09761865210411388,.08619016153195327,.08619016153195327,.0733464814110803,.0733464814110803,.05929858491543678,.05929858491543678,.04427743881741981,.04427743881741981,.028531388628933663,.028531388628933663,.0123412297999872,.0123412297999872],arcfn:function(t,e){var i=e(t),n=i.x*i.x+i.y*i.y;return void 0!==i.z&&(n+=i.z*i.z),s(n)},compute:function(t,e,i){if(0===t)return e[0];var n=e.length-1;if(1===t)return e[n];var r=e,o=1-t;if(0===n)return e[0];if(1===n)return c={x:o*r[0].x+t*r[1].x,y:o*r[0].y+t*r[1].y},i&&(c.z=o*r[0].z+t*r[1].z),c;if(n<4){var s,h,p,a=o*o,u=t*t,f=0;2===n?(r=[r[0],r[1],r[2],y],s=a,h=o*t*2,p=u):3===n&&(s=a*o,h=a*t*3,p=o*u*3,f=t*u);var c={x:s*r[0].x+h*r[1].x+p*r[2].x+f*r[3].x,y:s*r[0].y+h*r[1].y+p*r[2].y+f*r[3].y};return i&&(c.z=s*r[0].z+h*r[1].z+p*r[2].z+f*r[3].z),c}for(var l=JSON.parse(JSON.stringify(e));l.length>1;){for(var x=0;x<l.length-1;x++)l[x]={x:l[x].x+(l[x+1].x-l[x].x)*t,y:l[x].y+(l[x+1].y-l[x].y)*t},void 0!==l[x].z&&(l[x]=l[x].z+(l[x+1].z-l[x].z)*t);l.splice(l.length-1,1)}return l[0]},derive:function(t,e){for(var i=[],n=t,r=n.length,o=r-1;r>1;r--,o--){for(var s,h=[],p=0;p<o;p++)s={x:o*(n[p+1].x-n[p].x),y:o*(n[p+1].y-n[p].y)},e&&(s.z=o*(n[p+1].z-n[p].z)),h.push(s);i.push(h),n=h}return i},between:function(t,e,i){return e<=t&&t<=i||x.approximately(t,e)||x.approximately(t,i)},approximately:function(t,i,n){return e(t-i)<=(n||1e-6)},length:function(t){var e,i,n=0,r=x.Tvalues.length;for(e=0;e<r;e++)i=.5*x.Tvalues[e]+.5,n+=x.Cvalues[e]*x.arcfn(i,t);return.5*n},map:function(t,e,i,n,r){return n+(r-n)*((t-e)/(i-e))},lerp:function(t,e,i){var n={x:e.x+t*(i.x-e.x),y:e.y+t*(i.y-e.y)};return e.z&&i.z&&(n.z=e.z+t*(i.z-e.z)),n},pointToString:function(t){var e=t.x+"/"+t.y;return void 0!==t.z&&(e+="/"+t.z),e},pointsToString:function(t){return"["+t.map(x.pointToString).join(", ")+"]"},copy:function(t){return JSON.parse(JSON.stringify(t))},angle:function(t,e,i){var n=e.x-t.x,r=e.y-t.y,s=i.x-t.x,h=i.y-t.y;return o(n*h-r*s,n*s+r*h)},round:function(t,e){var i=""+t,n=i.indexOf(".");return parseFloat(i.substring(0,n+1+e))},dist:function(t,e){var i=t.x-e.x,n=t.y-e.y;return s(i*i+n*n)},closest:function(t,e){var i,n,r=h(2,63);return t.forEach(function(t,o){(n=x.dist(e,t))<r&&(r=n,i=o)}),{mdist:r,mpos:i}},abcratio:function(t,i){if(2!==i&&3!==i)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var n=h(t,i)+h(1-t,i);return e((n-1)/n)},projectionratio:function(t,e){if(2!==e&&3!==e)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var i=h(1-t,e);return i/(h(t,e)+i)},lli8:function(t,e,i,n,r,o,s,h){var p=(t-i)*(o-h)-(e-n)*(r-s);return 0!=p&&{x:((t*n-e*i)*(r-s)-(t-i)*(r*h-o*s))/p,y:((t*n-e*i)*(o-h)-(e-n)*(r*h-o*s))/p}},lli4:function(t,e,i,n){var r=t.x,o=t.y,s=e.x,h=e.y,p=i.x,a=i.y,u=n.x,f=n.y;return x.lli8(r,o,s,h,p,a,u,f)},lli:function(t,e){return x.lli4(t,t.c,e,e.c)},makeline:function(t,e){var i=bezier,n=t.x,r=t.y,o=e.x,s=e.y,h=(o-n)/3,p=(s-r)/3;return new i(n,r,n+h,r+p,n+2*h,r+2*p,o,s)},findbbox:function(t){var e=c,i=c,n=l,r=l;return t.forEach(function(t){var o=t.bbox();e>o.x.min&&(e=o.x.min),i>o.y.min&&(i=o.y.min),n<o.x.max&&(n=o.x.max),r<o.y.max&&(r=o.y.max)}),{x:{min:e,mid:(e+n)/2,max:n,size:n-e},y:{min:i,mid:(i+r)/2,max:r,size:r-i}}},shapeintersections:function(t,e,i,n,r){if(!x.bboxoverlap(e,n))return[];var o=[],s=[t.startcap,t.forward,t.back,t.endcap],h=[i.startcap,i.forward,i.back,i.endcap];return s.forEach(function(e){e.virtual||h.forEach(function(n){if(!n.virtual){var s=e.intersects(n,r);s.length>0&&(s.c1=e,s.c2=n,s.s1=t,s.s2=i,o.push(s))}})}),o},makeshape:function(t,e,i){var n=e.points.length,r=t.points.length,o=x.makeline(e.points[n-1],t.points[0]),s=x.makeline(t.points[r-1],e.points[0]),h={startcap:o,forward:t,back:e,endcap:s,bbox:x.findbbox([o,t,e,s])},p=x;return h.intersections=function(t){return p.shapeintersections(h,h.bbox,t,t.bbox,i)},h},getminmax:function(t,e,i){if(!i)return{min:0,max:0};var n,r,o=c,s=l;-1===i.indexOf(0)&&(i=[0].concat(i)),-1===i.indexOf(1)&&i.push(1);for(var h=0,p=i.length;h<p;h++)n=i[h],(r=t.get(n))[e]<o&&(o=r[e]),r[e]>s&&(s=r[e]);return{min:o,mid:(o+s)/2,max:s,size:s-o}},align:function(t,e){var r=e.p1.x,s=e.p1.y,h=-o(e.p2.y-s,e.p2.x-r);return t.map(function(t){return{x:(t.x-r)*i(h)-(t.y-s)*n(h),y:(t.x-r)*n(h)+(t.y-s)*i(h)}})},roots:function(t,e){e=e||{p1:{x:0,y:0},p2:{x:1,y:0}};var n=t.length-1,o=x.align(t,e),h=function(t){return 0<=t&&t<=1};if(2===n){if(0!==(d=(g=o[0].y)-2*(m=o[1].y)+(v=o[2].y))){var a=-s(m*m-g*v),f=-g+m;return[-(a+f)/d,-(-a+f)/d].filter(h)}return m!==v&&0===d?[(2*m-v)/(2*m-2*v)].filter(h):[]}var c=o[0].y,l=o[1].y,y=o[2].y,d=3*l-c-3*y+o[3].y,g=3*c-6*l+3*y,m=-3*c+3*l,v=c;if(x.approximately(d,0)){if(x.approximately(g,0))return x.approximately(m,0)?[]:[-v/m].filter(h);var b=2*g;return[((w=s(m*m-4*g*v))-m)/b,(-m-w)/b].filter(h)}var w,P,z=(o=(3*(m/=d)-(g/=d)*g)/3)/3,O=(w=(2*g*g*g-9*g*m+27*(v/=d))/27)/2,S=O*O+z*z*z;if(S<0){var $=-o/3,_=s($*$*$),k=-w/(2*_),I=r(k<-1?-1:k>1?1:k),M=2*p(_);return[M*i(I/3)-g/3,M*i((I+u)/3)-g/3,M*i((I+2*u)/3)-g/3].filter(h)}if(0===S)return[2*(P=O<0?p(-O):-p(O))-g/3,-P-g/3].filter(h);var A=s(S);return[(P=p(-O+A))-p(O+A)-g/3].filter(h)},droots:function(t){if(3===t.length){var e=t[0],i=t[1],n=t[2],r=e-2*i+n;if(0!==r){var o=-s(i*i-e*n),h=-e+i;return[-(o+h)/r,-(-o+h)/r]}return i!==n&&0===r?[(2*i-n)/(2*(i-n))]:[]}if(2===t.length)return(e=t[0])!==(i=t[1])?[e/(e-i)]:[]},curvature:function(t,e,i){var n,r,o=x.derive(e),p=o[0],a=o[1],u=x.compute(t,p),f=x.compute(t,a);return i?(n=s(h(u.y*f.z-f.y*u.z,2)+h(u.z*f.x-f.z*u.x,2)+h(u.x*f.y-f.x*u.y,2)),r=h(u.x*u.x+u.y*u.y+u.z*u.z,2/3)):(n=u.x*f.y-u.y*f.x,r=h(u.x*u.x+u.y*u.y,2/3)),0===n||0===r?{k:0,r:0}:{k:n/r,r:r/n}},inflections:function(t){if(t.length<4)return[];var e=x.align(t,{p1:t[0],p2:t.slice(-1)[0]}),i=e[2].x*e[1].y,n=e[3].x*e[1].y,r=e[1].x*e[2].y,o=18*(-3*i+2*n+3*r-(f=e[3].x*e[2].y)),s=18*(3*i-n-3*r),h=18*(r-i);if(x.approximately(o,0)){if(!x.approximately(s,0)){var p=-h/s;if(0<=p&&p<=1)return[p]}return[]}var a=s*s-4*o*h,u=Math.sqrt(a),f=2*o;return x.approximately(f,0)?[]:[(u-s)/f,-(s+u)/f].filter(function(t){return 0<=t&&t<=1})},bboxoverlap:function(t,i){var n,r,o,s,h,p=["x","y"],a=p.length;for(n=0;n<a;n++)if(o=t[r=p[n]].mid,s=i[r].mid,h=(t[r].size+i[r].size)/2,e(o-s)>=h)return!1;return!0},expandbox:function(t,e){e.x.min<t.x.min&&(t.x.min=e.x.min),e.y.min<t.y.min&&(t.y.min=e.y.min),e.z&&e.z.min<t.z.min&&(t.z.min=e.z.min),e.x.max>t.x.max&&(t.x.max=e.x.max),e.y.max>t.y.max&&(t.y.max=e.y.max),e.z&&e.z.max>t.z.max&&(t.z.max=e.z.max),t.x.mid=(t.x.min+t.x.max)/2,t.y.mid=(t.y.min+t.y.max)/2,t.z&&(t.z.mid=(t.z.min+t.z.max)/2),t.x.size=t.x.max-t.x.min,t.y.size=t.y.max-t.y.min,t.z&&(t.z.size=t.z.max-t.z.min)},pairiteration:function(t,e,i){var n=t.bbox(),r=e.bbox(),o=1e5,s=i||.5;if(n.x.size+n.y.size<s&&r.x.size+r.y.size<s)return[(o*(t._t1+t._t2)/2|0)/o+"/"+(o*(e._t1+e._t2)/2|0)/o];var h=t.split(.5),p=e.split(.5),a=[{left:h.left,right:p.left},{left:h.left,right:p.right},{left:h.right,right:p.right},{left:h.right,right:p.left}];a=a.filter(function(t){return x.bboxoverlap(t.left.bbox(),t.right.bbox())});var u=[];return 0===a.length?u:(a.forEach(function(t){u=u.concat(x.pairiteration(t.left,t.right,s))}),u=u.filter(function(t,e){return u.indexOf(t)===e}))},getccenter:function(t,e,r){var s,h=e.x-t.x,p=e.y-t.y,a=r.x-e.x,c=r.y-e.y,l=h*i(f)-p*n(f),y=h*n(f)+p*i(f),d=a*i(f)-c*n(f),g=a*n(f)+c*i(f),m=(t.x+e.x)/2,v=(t.y+e.y)/2,b=(e.x+r.x)/2,w=(e.y+r.y)/2,P=m+l,z=v+y,O=b+d,S=w+g,$=x.lli8(m,v,P,z,b,w,O,S),_=x.dist($,t),k=o(t.y-$.y,t.x-$.x),I=o(e.y-$.y,e.x-$.x),M=o(r.y-$.y,r.x-$.x);return k<M?((k>I||I>M)&&(k+=u),k>M&&(s=M,M=k,k=s)):M<I&&I<k?(s=M,M=k,k=s):M+=u,$.s=k,$.e=M,$.r=_,$},numberSort:function(t,e){return t-e}},t.exports=x}),polyBezier=createCommonjsModule(function(t){var e,i;e=utils,(i=function(t){this.curves=[],this._3d=!1,t&&(this.curves=t,this._3d=this.curves[0]._3d)}).prototype={valueOf:function(){return this.toString()},toString:function(){return"["+this.curves.map(function(t){return e.pointsToString(t.points)}).join(", ")+"]"},addCurve:function(t){this.curves.push(t),this._3d=this._3d||t._3d},length:function(){return this.curves.map(function(t){return t.length()}).reduce(function(t,e){return t+e})},curve:function(t){return this.curves[t]},bbox:function(){for(var t=this.curves,i=t[0].bbox(),n=1;n<t.length;n++)e.expandbox(i,t[n].bbox());return i},offset:function(t){var e=[];return this.curves.forEach(function(i){e=e.concat(i.offset(t))}),new i(e)}},t.exports=i});function normalizePath(t){var e,i,n,r,o,s,h=(t=t.replace(/,/g," ").replace(/-/g," - ").replace(/-\s+/g,"-").replace(/([a-zA-Z])/g," $1 ")).replace(/([a-zA-Z])\s?/g,"|$1").split("|"),p=h.length,a=[],u=0,f=0,c=0,l=0,y=0,x=0,d=0,g=0,m="";for(e=1;e<p;e++)if(r=(n=(i=h[e]).substring(0,1)).toLowerCase(),o=(a=(a=i.replace(n,"").trim().split(" ")).filter(function(t){return""!==t}).map(parseFloat)).length,"m"===r){if(m+="M ","m"===n?(c+=a[0],l+=a[1]):(c=a[0],l=a[1]),u=c,f=l,m+=c+" "+l+" ",o>2)for(s=0;s<o;s+=2)"m"===n?(c+=a[s],l+=a[s+1]):(c=a[s],l=a[s+1]),m+=["L",c,l,""].join(" ")}else if("l"===r)for(s=0;s<o;s+=2)"l"===n?(c+=a[s],l+=a[s+1]):(c=a[s],l=a[s+1]),m+=["L",c,l,""].join(" ");else if("h"===r)for(s=0;s<o;s++)"h"===n?c+=a[s]:c=a[s],m+=["L",c,l,""].join(" ");else if("v"===r)for(s=0;s<o;s++)"v"===n?l+=a[s]:l=a[s],m+=["L",c,l,""].join(" ");else if("q"===r)for(s=0;s<o;s+=4)"q"===n?(y=c+a[s],x=l+a[s+1],c+=a[s+2],l+=a[s+3]):(y=a[s],x=a[s+1],c=a[s+2],l=a[s+3]),m+=["Q",y,x,c,l,""].join(" ");else if("t"===r)for(s=0;s<o;s+=2)y=c+(c-y),x=l+(l-x),"t"===n?(c+=a[s],l+=a[s+1]):(c=a[s],l=a[s+1]),m+=["Q",y,x,c,l,""].join(" ");else if("c"===r)for(s=0;s<o;s+=6)"c"===n?(y=c+a[s],x=l+a[s+1],d=c+a[s+2],g=l+a[s+3],c+=a[s+4],l+=a[s+5]):(y=a[s],x=a[s+1],d=a[s+2],g=a[s+3],c=a[s+4],l=a[s+5]),m+=["C",y,x,d,g,c,l,""].join(" ");else if("s"===r)for(s=0;s<o;s+=4)y=c+(c-d),x=l+(l-g),"s"===n?(d=c+a[s],g=l+a[s+1],c+=a[s+2],l+=a[s+3]):(d=a[s],g=a[s+1],c=a[s+2],l=a[s+3]),m+=["C",y,x,d,g,c,l,""].join(" ");else"z"===r&&(m+="Z ",c=u,l=f);return m.trim()}var normaliseSvg=normalizePath,M={x:!1,y:!1};function makeBezier(t,e,i){if("Z"!==e){if("M"!==e){var n=[!1,M.x,M.y].concat(i),r=new(t.bind.apply(t,n)),o=i.slice(-2);return M={x:o[0],y:o[1]},r}M={x:i[0],y:i[1]}}}function convertPath(t,e){for(var i,n,r=normaliseSvg(e).split(" "),o=new RegExp("[MLCQZ]",""),s=[],h={C:6,Q:4,L:2,M:2};r.length;)i=r.splice(0,1)[0],o.test(i)&&(n=makeBezier(t,i,r.splice(0,h[i]).map(parseFloat)))&&s.push(n);return new t.PolyBezier(s)}var svgToBeziers=convertPath,bezier=createCommonjsModule(function(t){!function(){var e=Math.abs,i=Math.min,n=Math.max,r=Math.cos,o=Math.sin,s=Math.acos,h=Math.sqrt,p=Math.PI,a={x:0,y:0,z:0},u=utils,f=polyBezier,c=function(t){var i=t&&t.forEach?t:[].slice.call(arguments),n=!1;if("object"==typeof i[0]){n=i.length;var r=[];i.forEach(function(t){["x","y","z"].forEach(function(e){void 0!==t[e]&&r.push(t[e])})}),i=r}var o=!1,s=i.length;if(n){if(n>4){if(1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");o=!0}}else if(6!==s&&8!==s&&9!==s&&12!==s&&1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");var h=!o&&(9===s||12===s)||t&&t[0]&&void 0!==t[0].z;this._3d=h;for(var p=[],a=0,f=h?3:2;a<s;a+=f){var c={x:i[a],y:i[a+1]};h&&(c.z=i[a+2]),p.push(c)}this.order=p.length-1,this.points=p;var l=["x","y"];h&&l.push("z"),this.dims=l,this.dimlen=l.length,function(t){for(var i=t.order,n=t.points,r=u.align(n,{p1:n[0],p2:n[i]}),o=0;o<r.length;o++)if(e(r[o].y)>1e-4)return void(t._linear=!1);t._linear=!0}(this),this._t1=0,this._t2=1,this.update()},l=svgToBeziers;function y(t,e,i,n,r){void 0===r&&(r=.5);var o=u.projectionratio(r,t),s=1-o,h={x:o*e.x+s*n.x,y:o*e.y+s*n.y},p=u.abcratio(r,t);return{A:{x:i.x+(i.x-h.x)/p,y:i.y+(i.y-h.y)/p},B:i,C:h}}c.SVGtoBeziers=function(t){return l(c,t)},c.quadraticFromPoints=function(t,e,i,n){if(void 0===n&&(n=.5),0===n)return new c(e,e,i);if(1===n)return new c(t,e,e);var r=y(2,t,e,i,n);return new c(t,r.A,i)},c.cubicFromPoints=function(t,e,i,n,r){void 0===n&&(n=.5);var o=y(3,t,e,i,n);void 0===r&&(r=u.dist(e,o.C));var s=r*(1-n)/n,h=u.dist(t,i),p=(i.x-t.x)/h,a=(i.y-t.y)/h,f=r*p,l=r*a,x=s*p,d=s*a,g=e.x-f,m=e.y-l,v=e.x+x,b=e.y+d,w=o.A,P=w.x+(g-w.x)/(1-n),z=w.y+(m-w.y)/(1-n),O=w.x+(v-w.x)/n,S=w.y+(b-w.y)/n,$={x:t.x+(P-t.x)/n,y:t.y+(z-t.y)/n},_={x:i.x+(O-i.x)/(1-n),y:i.y+(S-i.y)/(1-n)};return new c(t,$,_,i)};var x=function(){return u};c.getUtils=x,c.PolyBezier=f,c.prototype={getUtils:x,valueOf:function(){return this.toString()},toString:function(){return u.pointsToString(this.points)},toSVG:function(t){if(this._3d)return!1;for(var e=this.points,i=["M",e[0].x,e[0].y,2===this.order?"Q":"C"],n=1,r=e.length;n<r;n++)i.push(e[n].x),i.push(e[n].y);return i.join(" ")},update:function(){this._lut=[],this.dpoints=u.derive(this.points,this._3d),this.computedirection()},computedirection:function(){var t=this.points,e=u.angle(t[0],t[this.order],t[1]);this.clockwise=e>0},length:function(){return u.length(this.derivative.bind(this))},_lut:[],getLUT:function(t){if(t=t||100,this._lut.length===t)return this._lut;this._lut=[],t--;for(var e=0;e<=t;e++)this._lut.push(this.compute(e/t));return this._lut},on:function(t,e){e=e||5;for(var i,n=this.getLUT(),r=[],o=0,s=0;s<n.length;s++)i=n[s],u.dist(i,t)<e&&(r.push(i),o+=s/n.length);return!!r.length&&o/r.length},project:function(t){var e=this.getLUT(),i=e.length-1,n=u.closest(e,t),r=n.mdist,o=n.mpos;if(0===o||o===i){var s=o/i,h=this.compute(s);return h.t=s,h.d=r,h}var p,a,f,c=(o+1)/i,l=.1/i;for(r+=1,p=s=(o-1)/i;s<c+l;s+=l)a=this.compute(s),(f=u.dist(t,a))<r&&(r=f,p=s);return(a=this.compute(p)).t=p,a.d=r,a},get:function(t){return this.compute(t)},point:function(t){return this.points[t]},compute:function(t){return u.compute(t,this.points,this._3d)},raise:function(){for(var t,e,i=this.points,n=[i[0]],r=i.length,o=1;o<r;o++)t=i[o],e=i[o-1],n[o]={x:(r-o)/r*t.x+o/r*e.x,y:(r-o)/r*t.y+o/r*e.y};return n[r]=i[r-1],new c(n)},derivative:function(t){var e,i,n=1-t,r=0,o=this.dpoints[0];2===this.order&&(o=[o[0],o[1],a],e=n,i=t),3===this.order&&(e=n*n,i=n*t*2,r=t*t);var s={x:e*o[0].x+i*o[1].x+r*o[2].x,y:e*o[0].y+i*o[1].y+r*o[2].y};return this._3d&&(s.z=e*o[0].z+i*o[1].z+r*o[2].z),s},curvature:function(t){return u.curvature(t,this.points,this._3d)},inflections:function(){return u.inflections(this.points)},normal:function(t){return this._3d?this.__normal3(t):this.__normal2(t)},__normal2:function(t){var e=this.derivative(t),i=h(e.x*e.x+e.y*e.y);return{x:-e.y/i,y:e.x/i}},__normal3:function(t){var e=this.derivative(t),i=this.derivative(t+.01),n=h(e.x*e.x+e.y*e.y+e.z*e.z),r=h(i.x*i.x+i.y*i.y+i.z*i.z);e.x/=n,e.y/=n,e.z/=n,i.x/=r,i.y/=r,i.z/=r;var o={x:i.y*e.z-i.z*e.y,y:i.z*e.x-i.x*e.z,z:i.x*e.y-i.y*e.x},s=h(o.x*o.x+o.y*o.y+o.z*o.z);o.x/=s,o.y/=s,o.z/=s;var p=[o.x*o.x,o.x*o.y-o.z,o.x*o.z+o.y,o.x*o.y+o.z,o.y*o.y,o.y*o.z-o.x,o.x*o.z-o.y,o.y*o.z+o.x,o.z*o.z];return{x:p[0]*e.x+p[1]*e.y+p[2]*e.z,y:p[3]*e.x+p[4]*e.y+p[5]*e.z,z:p[6]*e.x+p[7]*e.y+p[8]*e.z}},hull:function(t){var e,i=this.points,n=[],r=[],o=0,s=0,h=0;for(r[o++]=i[0],r[o++]=i[1],r[o++]=i[2],3===this.order&&(r[o++]=i[3]);i.length>1;){for(n=[],s=0,h=i.length-1;s<h;s++)e=u.lerp(t,i[s],i[s+1]),r[o++]=e,n.push(e);i=n}return r},split:function(t,e){if(0===t&&e)return this.split(e).left;if(1===e)return this.split(t).right;var i=this.hull(t),n={left:2===this.order?new c([i[0],i[3],i[5]]):new c([i[0],i[4],i[7],i[9]]),right:2===this.order?new c([i[5],i[4],i[2]]):new c([i[9],i[8],i[6],i[3]]),span:i};return n.left._t1=u.map(0,0,1,this._t1,this._t2),n.left._t2=u.map(t,0,1,this._t1,this._t2),n.right._t1=u.map(t,0,1,this._t1,this._t2),n.right._t2=u.map(1,0,1,this._t1,this._t2),e?(e=u.map(e,t,1,0,1),n.right.split(e).left):n},extrema:function(){var t,e,i=this.dims,n={},r=[];return i.forEach(function(i){e=function(t){return t[i]},t=this.dpoints[0].map(e),n[i]=u.droots(t),3===this.order&&(t=this.dpoints[1].map(e),n[i]=n[i].concat(u.droots(t))),n[i]=n[i].filter(function(t){return t>=0&&t<=1}),r=r.concat(n[i].sort(u.numberSort))}.bind(this)),r=r.sort(u.numberSort).filter(function(t,e){return r.indexOf(t)===e}),n.values=r,n},bbox:function(){var t=this.extrema(),e={};return this.dims.forEach(function(i){e[i]=u.getminmax(this,i,t[i])}.bind(this)),e},overlaps:function(t){var e=this.bbox(),i=t.bbox();return u.bboxoverlap(e,i)},offset:function(t,e){if(void 0!==e){var i=this.get(t),n=this.normal(t),r={c:i,n:n,x:i.x+n.x*e,y:i.y+n.y*e};return this._3d&&(r.z=i.z+n.z*e),r}if(this._linear){var o=this.normal(0),s=this.points.map(function(e){var i={x:e.x+t*o.x,y:e.y+t*o.y};return e.z&&n.z&&(i.z=e.z+t*o.z),i});return[new c(s)]}return this.reduce().map(function(e){return e.scale(t)})},simple:function(){if(3===this.order){var t=u.angle(this.points[0],this.points[3],this.points[1]),i=u.angle(this.points[0],this.points[3],this.points[2]);if(t>0&&i<0||t<0&&i>0)return!1}var n=this.normal(0),r=this.normal(1),o=n.x*r.x+n.y*r.y;return this._3d&&(o+=n.z*r.z),e(s(o))<p/3},reduce:function(){var t,i,n=0,r=0,o=[],s=[],h=this.extrema().values;for(-1===h.indexOf(0)&&(h=[0].concat(h)),-1===h.indexOf(1)&&h.push(1),n=h[0],t=1;t<h.length;t++)r=h[t],(i=this.split(n,r))._t1=n,i._t2=r,o.push(i),n=r;return o.forEach(function(t){for(n=0,r=0;r<=1;)for(r=n+.01;r<=1.01;r+=.01)if(!(i=t.split(n,r)).simple()){if(e(n-(r-=.01))<.01)return[];(i=t.split(n,r))._t1=u.map(n,0,1,t._t1,t._t2),i._t2=u.map(r,0,1,t._t1,t._t2),s.push(i),n=r;break}n<1&&((i=t.split(n,1))._t1=u.map(n,0,1,t._t1,t._t2),i._t2=t._t2,s.push(i))}),s},scale:function(t){var e=this.order,i=!1;if("function"==typeof t&&(i=t),i&&2===e)return this.raise().scale(i);var n=this.clockwise,r=i?i(0):t,o=i?i(1):t,s=[this.offset(0,10),this.offset(1,10)],p=u.lli4(s[0],s[0].c,s[1],s[1].c);if(!p)throw new Error("cannot scale this curve. Try reducing it first.");var a=this.points,f=[];return[0,1].forEach(function(t){var i=f[t*e]=u.copy(a[t*e]);i.x+=(t?o:r)*s[t].n.x,i.y+=(t?o:r)*s[t].n.y}.bind(this)),i?([0,1].forEach(function(r){if(2!==this.order||!r){var o=a[r+1],s={x:o.x-p.x,y:o.y-p.y},u=i?i((r+1)/e):t;i&&!n&&(u=-u);var c=h(s.x*s.x+s.y*s.y);s.x/=c,s.y/=c,f[r+1]={x:o.x+u*s.x,y:o.y+u*s.y}}}.bind(this)),new c(f)):([0,1].forEach(function(t){if(2!==this.order||!t){var i=f[t*e],n=this.derivative(t),r={x:i.x+n.x,y:i.y+n.y};f[t+1]=u.lli4(i,r,p,a[t+1])}}.bind(this)),new c(f))},outline:function(t,e,i,n){e=void 0===e?t:e;var r,o=this.reduce(),s=o.length,h=[],p=[],a=0,c=this.length(),l=void 0!==i&&void 0!==n;function y(t,e,i,n,r){return function(o){var s=n/i,h=(n+r)/i,p=e-t;return u.map(o,0,1,t+s*p,t+h*p)}}o.forEach(function(r){P=r.length(),l?(h.push(r.scale(y(t,i,c,a,P))),p.push(r.scale(y(-e,-n,c,a,P)))):(h.push(r.scale(t)),p.push(r.scale(-e))),a+=P}),p=p.map(function(t){return(r=t.points)[3]?t.points=[r[3],r[2],r[1],r[0]]:t.points=[r[2],r[1],r[0]],t}).reverse();var x=h[0].points[0],d=h[s-1].points[h[s-1].points.length-1],g=p[s-1].points[p[s-1].points.length-1],m=p[0].points[0],v=u.makeline(g,x),b=u.makeline(d,m),w=[v].concat(h).concat([b]).concat(p),P=w.length;return new f(w)},outlineshapes:function(t,e,i){e=e||t;for(var n=this.outline(t,e).curves,r=[],o=1,s=n.length;o<s/2;o++){var h=u.makeshape(n[o],n[s-o],i);h.startcap.virtual=o>1,h.endcap.virtual=o<s/2-1,r.push(h)}return r},intersects:function(t,e){return t?t.p1&&t.p2?this.lineIntersects(t):(t instanceof c&&(t=t.reduce()),this.curveintersects(this.reduce(),t,e)):this.selfintersects(e)},lineIntersects:function(t){var e=i(t.p1.x,t.p2.x),r=i(t.p1.y,t.p2.y),o=n(t.p1.x,t.p2.x),s=n(t.p1.y,t.p2.y),h=this;return u.roots(this.points,t).filter(function(t){var i=h.get(t);return u.between(i.x,e,o)&&u.between(i.y,r,s)})},selfintersects:function(t){var e,i,n,r,o=this.reduce(),s=o.length-2,h=[];for(e=0;e<s;e++)n=o.slice(e,e+1),r=o.slice(e+2),i=this.curveintersects(n,r,t),h=h.concat(i);return h},curveintersects:function(t,e,i){var n=[];t.forEach(function(t){e.forEach(function(e){t.overlaps(e)&&n.push({left:t,right:e})})});var r=[];return n.forEach(function(t){var e=u.pairiteration(t.left,t.right,i);e.length>0&&(r=r.concat(e))}),r},arcs:function(t){t=t||.5;return this._iterate(t,[])},_error:function(t,i,n,r){var o=(r-n)/4,s=this.get(n+o),h=this.get(r-o),p=u.dist(t,i),a=u.dist(t,s),f=u.dist(t,h);return e(a-p)+e(f-p)},_iterate:function(t,e){var i,n=0,s=1;do{i=0,s=1;var h,p,a,f,c,l=this.get(n),y=!1,x=!1,d=s,g=1;do{if(x=y,f=a,d=(n+s)/2,h=this.get(d),p=this.get(s),(a=u.getccenter(l,h,p)).interval={start:n,end:s},y=this._error(a,l,n,s)<=t,(c=x&&!y)||(g=s),y){if(s>=1){if(a.interval.end=g=1,f=a,s>1){var m={x:a.x+a.r*r(a.e),y:a.y+a.r*o(a.e)};a.e+=u.angle({x:a.x,y:a.y},m,this.get(1))}break}s+=(s-n)/2}else s=d}while(!c&&i++<100);if(i>=100)break;f=f||a,e.push(f),n=g}while(s<1);return e}},t.exports=c}()}),bezierJs=bezier;function Path(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new Attributes,this.ops=[]}function pathOffset(t,e){let i,n=[],r=!1;for(let o in t.ops){let s=t.ops[o];if("line"===s.type){let t=offsetLine(i,s.to,e);t&&n.push(t)}else if("curve"===s.type){let t,r;t=i.sitsRoughlyOn(s.cp1)?(new Path).move(i).curve(s.cp1,s.cp2,s.to).shiftAlong(2):s.cp1,r=s.cp2.sitsRoughlyOn(s.to)?(new Path).move(s.to).curve(s.cp2,s.cp1,i).shiftAlong(2):s.cp2;let o=new bezierJs({x:i.x,y:i.y},{x:t.x,y:t.y},{x:r.x,y:r.y},{x:s.to.x,y:s.to.y});for(let t of o.offset(e))n.push(asPath(t))}else"close"===s.type&&(r=!0);s.to&&(i=s.to)}return joinPaths(n,r)}function offsetLine(t,e,i){if(t.x===e.x&&t.y===e.y)return!1;let n=t.angle(e)-90;return(new Path).move(t.shift(n,i)).line(e.shift(n,i))}function asPath(t){return(new Path).move(new Point(t.points[0].x,t.points[0].y)).curve(new Point(t.points[1].x,t.points[1].y),new Point(t.points[2].x,t.points[2].y),new Point(t.points[3].x,t.points[3].y))}function joinPaths(t,e=!1){let i,n=(new Path).move(t[0].ops[0].to);for(let e of t)for(let t of e.ops){if("curve"===t.type)n.curve(t.cp1,t.cp2,t.to);else{if("close"===t.type)throw new Error("Cannot join a closed paths with another");i&&!t.to.sitsRoughlyOn(i)&&n.line(t.to)}t.to&&(i=t.to)}return e&&n.close(),n}function shiftAlongBezier(t,e){let i,n,r,o,s=0;for(let h=0;h<=100;h++){if(r=h/100,n=new Point((n=e.get(r)).x,n.y),h>0){if(s+(o=n.dist(i))>t)return n;s+=o}i=n}}function lineBoundingBox(t){let e=t.from,i=t.to;return e.x===i.x?e.y<i.y?{topLeft:e,bottomRight:i}:{topLeft:i,bottomRight:e}:e.y===i.y?e.x<i.x?{topLeft:e,bottomRight:i}:{topLeft:i,bottomRight:e}:e.x<i.x?e.y<i.y?{topLeft:e,bottomRight:i}:{topLeft:new Point(e.x,i.y),bottomRight:new Point(i.x,e.y)}:e.x>i.x?e.y<i.y?{topLeft:new Point(i.x,e.y),bottomRight:new Point(e.x,i.y)}:{topLeft:new Point(i.x,i.y),bottomRight:new Point(e.x,e.y)}:void 0}function curveBoundingBox(t){let e=t.bbox();return{topLeft:new Point(e.x.min,e.y.min),bottomRight:new Point(e.x.max,e.y.max)}}function bbbbox(t){let e=1/0,i=-1/0,n=1/0,r=-1/0;for(let o of t)o.topLeft.x<e&&(e=o.topLeft.x),o.topLeft.y<n&&(n=o.topLeft.y),o.bottomRight.x>i&&(i=o.bottomRight.x),o.bottomRight.y>r&&(r=o.bottomRight.y);return{topLeft:new Point(e,n),bottomRight:new Point(i,r)}}function edgeCurveAsBezier(t){return new bezierJs({x:t.from.x,y:t.from.y},{x:t.cp1.x,y:t.cp1.y},{x:t.cp2.x,y:t.cp2.y},{x:t.to.x,y:t.to.y})}function addIntersectionsToArray(t,e){if(t&&"object"==typeof t)if("number"==typeof t.x)e.push(t);else for(let i of t)e.push(i)}function capitalize(t){return t.charAt(0).toUpperCase()+t.slice(1)}function macroName(t){return`_macro_${t}`}function beamsIntersect(t,e,i,n){let r=t.slope(e),o=i.slope(n);if(r===o)return!1;if(t.x===e.x)return new Point(t.x,o*t.x+(i.y-o*i.x));if(i.x===n.x)return new Point(i.x,r*i.x+(t.y-r*t.x));{t.x>e.x&&(t=e.copy()),i.x>n.x&&(i=n.copy());let s=t.y-r*t.x,h=(i.y-o*i.x-s)/(r-o);return new Point(h,r*h+s)}}function linesIntersect(t,e,i,n){let r=beamsIntersect(t,e,i,n);if(!r)return!1;let o=t.dist(e),s=i.dist(n),h=t.dist(r)+r.dist(e),p=i.dist(r)+r.dist(n);return Math.round(o)==Math.round(h)&&Math.round(s)==Math.round(p)&&r}function pointOnBeam(t,e,i,n=1e6){if(t.sitsOn(i))return!0;if(e.sitsOn(i))return!0;let r=i.dx(t)*e.dy(t)-i.dy(t)*e.dx(t);return 0===Math.abs(Math.round(r*n)/n)}function pointOnLine(t,e,i,n=1e6){if(!pointOnBeam(t,e,i,n))return!1;let r=t.dist(e),o=t.dist(i)+i.dist(e);return Math.round(r)==Math.round(o)}function pointOnCurve(t,e,i,n,r){if(t.sitsOn(r))return!0;if(n.sitsOn(r))return!0;let o=new bezierJs({x:t.x,y:t.y},{x:e.x,y:e.y},{x:i.x,y:i.y},{x:n.x,y:n.y}).intersects({p1:{x:r.x-1,y:r.y},p2:{x:r.x+1,y:r.y}});return o.length>0&&o.shift()}function splitCurve(t,e,i,n,r){let[o,s]=(new Path).move(t).curve(e,i,n).split(r);return[{start:o.ops[0].to,cp1:o.ops[1].cp1,cp2:o.ops[1].cp2,end:o.ops[1].to},{start:s.ops[0].to,cp1:s.ops[1].cp1,cp2:s.ops[1].cp2,end:s.ops[1].to}]}function beamIntersectsX(t,e,i){if(t.x===e.x)return!1;return beamsIntersect(t,e,new Point(i,-10),new Point(i,10))}function beamIntersectsY(t,e,i){if(t.y===e.y)return!1;return beamsIntersect(t,e,new Point(-10,i),new Point(10,i))}function units(t,e="metric"){return"imperial"===e?round(t/25.4)+'"':round(t/10)+"cm"}function lineIntersectsCurve(t,e,i,n,r,o){let s=[],h=new bezierJs({x:i.x,y:i.y},{x:n.x,y:n.y},{x:r.x,y:r.y},{x:o.x,y:o.y}),p={p1:{x:t.x,y:t.y},p2:{x:e.x,y:e.y}};for(let t of h.intersects(p)){let e=h.get(t);s.push(new Point(e.x,e.y))}return 0!==s.length&&(1===s.length?s[0]:s)}function curveIntersectsX(t,e,i,n,r){return lineIntersectsCurve(new Point(r,-1e4),new Point(r,1e4),t,e,i,n)}function curveIntersectsY(t,e,i,n,r){return lineIntersectsCurve(new Point(-1e4,r),new Point(1e4,r),t,e,i,n)}function curvesIntersect(t,e,i,n,r,o,s,h){let p=[],a=new bezierJs({x:t.x,y:t.y},{x:e.x,y:e.y},{x:i.x,y:i.y},{x:n.x,y:n.y}),u=new bezierJs({x:r.x,y:r.y},{x:o.x,y:o.y},{x:s.x,y:s.y},{x:h.x,y:h.y});for(let t of a.intersects(u,.005)){let e=a.get(t.substr(0,t.indexOf("/")));p.push(new Point(e.x,e.y))}if(0===p.length)return!1;if(1===p.length)return p.shift();{let t=[];for(let e of p){let i=!1;for(let n of t)e.sitsRoughlyOn(n)&&(i=!0);i||t.push(e)}return t}}function circlesIntersect(t,e,i,n,r="x"){let o=t.dx(i),s=t.dy(i),h=t.dist(i);if(h>parseFloat(e)+parseFloat(n))return!1;if(h<parseFloat(n)-parseFloat(e))return!1;if(0===h&&e===n)return!1;let p=(Math.pow(e,2)-Math.pow(n,2)+Math.pow(h,2))/(2*h),a=Math.sqrt(Math.pow(e,2)-Math.pow(p,2)),u=t.x+p*o/h,f=t.y+p*s/h,c=new Point(u+a*s/h,f-a*o/h),l=new Point(u-a*s/h,f+a*o/h);return"x"===r&&c.x<=l.x||"y"===r&&c.y<=l.y?[c,l]:[l,c]}function beamIntersectsCircle(t,e,i,n,r="x"){let o=n.x-i.x,s=n.y-i.y,h=Math.pow(o,2)+Math.pow(s,2),p=2*(o*(i.x-t.x)+s*(i.y-t.y)),a=Math.pow(i.x-t.x,2)+Math.pow(i.y-t.y,2)-Math.pow(e,2),u=Math.pow(p,2)-4*h*a;if(h<=1e-7||u<0)return!1;if(0===u){let t=-1*p/(2*h);return[new Point(i.x+t*o,i.y+t*s)]}{let t=(-1*p+Math.sqrt(u))/(2*h),e=new Point(i.x+t*o,i.y+t*s);t=(-1*p-Math.sqrt(u))/(2*h);let n=new Point(i.x+t*o,i.y+t*s);return"x"===r&&e.x<=n.x||"y"===r&&e.y<=n.y?[e,n]:[n,e]}}function lineIntersectsCircle(t,e,i,n,r="x"){let o=beamIntersectsCircle(t,e,i,n,r);if(!1===o)return!1;if(1===o.length)return!!pointOnLine(i,n,o[0])&&o;{let t=o[0],e=o[1];if(!pointOnLine(i,n,t,5)&&!pointOnLine(i,n,e,5))return!1;if(pointOnLine(i,n,t,5)&&pointOnLine(i,n,e,5))return"x"===r&&t.x<=e.x||"y"===r&&t.y<=e.y?[t,e]:[e,t];if(pointOnLine(i,n,t,5))return[t];if(pointOnLine(i,n,e,5))return[e]}}function curveEdge(t,e,i=500){let n,r=1/0,o=1/0;"bottom"===e&&(o=-1/0),"right"===e&&(r=-1/0);for(let s=0;s<i;s++)n=t.get(s/i),("top"===e&&n.y<o||"bottom"===e&&n.y>o||"right"===e&&n.x>r||"left"===e&&n.x<r)&&(r=n.x,o=n.y);return new Point(r,o)}function stretchToScale(t){return 1/(1+parseFloat(t))}function round(t){return Math.round(100*t)/100}function sampleStyle(t,e){return`stroke: hsl(${330/e*(t-1)}, 100%, 35%);`}function deg2rad(t){return t*(Math.PI/180)}Path.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},Path.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},Path.prototype.curve=function(t,e,i){return this.ops.push({type:"curve",cp1:t,cp2:e,to:i}),this},Path.prototype._curve=function(t,e){let i=this.ops.slice(-1).pop().to;return this.ops.push({type:"curve",cp1:i,cp2:t,to:e}),this},Path.prototype.curve_=function(t,e){let i=e.copy();return this.ops.push({type:"curve",cp1:t,cp2:i,to:e}),this},Path.prototype.close=function(){return this.ops.push({type:"close"}),this},Path.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},Path.prototype.asPathstring=function(){let t="";for(let e of this.ops)switch(e.type){case"move":t+=`M ${e.to.x},${e.to.y}`;break;case"line":t+=` L ${e.to.x},${e.to.y}`;break;case"curve":t+=` C ${e.cp1.x},${e.cp1.y} ${e.cp2.x},${e.cp2.y} ${e.to.x},${e.to.y}`;break;case"close":t+=" z"}return t},Path.prototype.offset=function(t){return pathOffset(this,t)},Path.prototype.length=function(){let t,e,i=0;for(let n in this.ops){let r=this.ops[n];"move"===r.type?e=r.to:"line"===r.type?i+=t.dist(r.to):"curve"===r.type?i+=new bezierJs({x:t.x,y:t.y},{x:r.cp1.x,y:r.cp1.y},{x:r.cp2.x,y:r.cp2.y},{x:r.to.x,y:r.to.y}).length():"close"===r.type&&(i+=t.dist(e)),r.to&&(t=r.to)}return round(i)},Path.prototype.start=function(){return this.ops[0].to},Path.prototype.end=function(){let t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},Path.prototype.boundary=function(){if(this.topLeft)return this;let t,e=new Point(1/0,1/0),i=new Point(-1/0,-1/0),n=[];for(let r in this.ops){let o=this.ops[r];if("move"===o.type||"line"===o.type)o.to.x<e.x&&(e.x=o.to.x,n.leftOp=r),o.to.y<e.y&&(e.y=o.to.y,n.topOp=r),o.to.x>i.x&&(i.x=o.to.x,n.rightOp=r),o.to.y>i.y&&(i.y=o.to.y,n.bottomOp=r);else if("curve"===o.type){let s=new bezierJs({x:t.x,y:t.y},{x:o.cp1.x,y:o.cp1.y},{x:o.cp2.x,y:o.cp2.y},{x:o.to.x,y:o.to.y}).bbox();s.x.min<e.x&&(e.x=s.x.min,n.leftOp=r),s.y.min<e.y&&(e.y=s.y.min,n.topOp=r),s.x.max>i.x&&(i.x=s.x.max,n.rightOp=r),s.y.max>i.y&&(i.y=s.y.max,n.bottomOp=r)}o.to&&(t=o.to)}this.topLeft=e,this.bottomRight=i;for(let t of["top","left","bottom","right"]){let e=t+"Op";this[e]=this.ops[n[e]],this[e].from="move"===this[e].type?this[e].to:this.ops[n[e]-1].to}return this},Path.prototype.clone=function(){let t=new Path;t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[];for(let e in this.ops){let i=this.ops[e];t.ops[e]={type:i.type},"move"===i.type||"line"===i.type?t.ops[e].to=i.to.clone():"curve"===i.type&&(t.ops[e].to=i.to.clone(),t.ops[e].cp1=i.cp1.clone(),t.ops[e].cp2=i.cp2.clone())}return t},Path.prototype.join=function(t,e=!1){return joinPaths([this,t],e)},Path.prototype.shiftAlong=function(t){let e,i=0;for(let n in this.ops){let r=this.ops[n];if("line"===r.type){let n=r.to.dist(e);if(i+n>t)return e.shiftTowards(r.to,t-i);i+=n}else if("curve"===r.type){let n=new bezierJs({x:e.x,y:e.y},{x:r.cp1.x,y:r.cp1.y},{x:r.cp2.x,y:r.cp2.y},{x:r.to.x,y:r.to.y}),o=n.length();if(i+o>t)return shiftAlongBezier(t-i,n);i+=o}e=r.to}throw new Error("Ran out of path to shift along")},Path.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},Path.prototype.bbox=function(){let t,e=[];for(let i in this.ops){let n=this.ops[i];"line"===n.type?e.push(lineBoundingBox({from:t,to:n.to})):"curve"===n.type&&e.push(curveBoundingBox(new bezierJs({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}))),n.to&&(t=n.to)}return bbbbox(e)},Path.prototype.reverse=function(){let t,e=[],i=!1;for(let n in this.ops){let r=this.ops[n];"line"===r.type?r.to.sitsOn(t)||e.push((new Path).move(r.to).line(t)):"curve"===r.type?e.push((new Path).move(r.to).curve(r.cp2,r.cp1,t)):"close"===r.type&&(i=!0),r.to&&(t=r.to)}let n=(new Path).move(t);for(let t of e.reverse())n.ops.push(t.ops[1]);return i&&n.close(),n},Path.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new Point(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new Point(this.topLeft.x,this.bottomRight.y);{let e=t+"Op";if("move"===this[e].type)return this[e].to;if("line"===this[e].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[e].type){return curveEdge(edgeCurveAsBezier(this[e]),t)}}},Path.prototype.divide=function(){let t,e,i=[];for(let n in this.ops){let r=this.ops[n];"move"===r.type?e=r.to:"line"===r.type?r.to.sitsRoughlyOn(t)||i.push((new Path).move(t).line(r.to)):"curve"===r.type?i.push((new Path).move(t).curve(r.cp1,r.cp2,r.to)):"close"===r.type&&i.push((new Path).move(t).line(e)),r.to&&(t=r.to)}return i},Path.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},Path.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},Path.prototype.intersectsAxis=function(t=!1,e){if(!1===t)throw new Error("Path.intersects[X-Y] requires an value as parameter");let i=[],n="x"===e?new Point(t,-1e5):new Point(-1e4,t),r="x"===e?new Point(t,1e5):new Point(1e5,t);for(let t of this.divide())"line"===t.ops[1].type?addIntersectionsToArray(linesIntersect(t.ops[0].to,t.ops[1].to,n,r),i):"curve"===t.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(n,r,t.ops[0].to,t.ops[1].cp1,t.ops[1].cp2,t.ops[1].to),i);return i},Path.prototype.intersects=function(t){if(this===t)throw new Error("Calculating intersections between two identical paths is bad idea");let e=[];for(let i of this.divide())for(let n of t.divide())"line"===i.ops[1].type?"line"===n.ops[1].type?addIntersectionsToArray(linesIntersect(i.ops[0].to,i.ops[1].to,n.ops[0].to,n.ops[1].to),e):"curve"===n.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(i.ops[0].to,i.ops[1].to,n.ops[0].to,n.ops[1].cp1,n.ops[1].cp2,n.ops[1].to),e):"curve"===i.ops[1].type&&("line"===n.ops[1].type?addIntersectionsToArray(lineIntersectsCurve(n.ops[0].to,n.ops[1].to,i.ops[0].to,i.ops[1].cp1,i.ops[1].cp2,i.ops[1].to),e):"curve"===n.ops[1].type&&addIntersectionsToArray(curvesIntersect(i.ops[0].to,i.ops[1].cp1,i.ops[1].cp2,i.ops[1].to,n.ops[0].to,n.ops[1].cp1,n.ops[1].cp2,n.ops[1].to),e));return e},Path.prototype.split=function(t){let e=this.divide(),i=!1,n=!1;for(let r in e){let o=e[r];if("line"===o.ops[1].type)pointOnLine(o.ops[0].to,o.ops[1].to,t)&&((i=e.slice(0,r)).push((new Path).move(o.ops[0].to).line(t)),r++,(n=e.slice(r)).unshift((new Path).move(t).line(o.ops[1].to)));else if("curve"===o.ops[1].type){let s=pointOnCurve(o.ops[0].to,o.ops[1].cp1,o.ops[1].cp2,o.ops[1].to,t);if(!1!==s){let t=new bezierJs({x:o.ops[0].to.x,y:o.ops[0].to.y},{x:o.ops[1].cp1.x,y:o.ops[1].cp1.y},{x:o.ops[1].cp2.x,y:o.ops[1].cp2.y},{x:o.ops[1].to.x,y:o.ops[1].to.y}).split(s);(i=e.slice(0,r)).push((new Path).move(new Point(t.left.points[0].x,t.left.points[0].y)).curve(new Point(t.left.points[1].x,t.left.points[1].y),new Point(t.left.points[2].x,t.left.points[2].y),new Point(t.left.points[3].x,t.left.points[3].y))),r++,(n=e.slice(r)).unshift((new Path).move(new Point(t.right.points[0].x,t.right.points[0].y)).curve(new Point(t.right.points[1].x,t.right.points[1].y),new Point(t.right.points[2].x,t.right.points[2].y),new Point(t.right.points[3].x,t.right.points[3].y)))}}}return i&&(i=joinPaths(i)),n&&(n=joinPaths(n)),[i,n]},Path.prototype.trim=function(){let t=this.divide();for(let e in t){let i=parseInt(e)+2,n=parseInt(t.length)-1;for(let r=i;r<n;r++){let i=t[e].intersects(t[r]);if(i.length>0){let n,o=i.pop(),s=t.slice(0,e),h=t.slice(parseInt(r)+1),p=new Path,a=!0;for(let i of[e,r]){let e=t[i].ops;if("line"===e[1].type)p.line(o);else if("curve"===e[1].type){let t,i=new bezierJs({x:e[0].to.x,y:e[0].to.y},{x:e[1].cp1.x,y:e[1].cp1.y},{x:e[1].cp2.x,y:e[1].cp2.y},{x:e[1].to.x,y:e[1].to.y}),n=pointOnCurve(e[0].to,e[1].cp1,e[1].cp2,e[1].to,o),r=i.split(n);t=a?r.left:r.right,p.curve(new Point(t.points[1].x,t.points[1].y),new Point(t.points[2].x,t.points[2].y),new Point(t.points[3].x,t.points[3].y))}a=!1}return n=s.length>0?joinPaths(s).join(p):p,h.length>0&&(n=n.join(joinPaths(h))),n.trim()}}}return this},Path.prototype.translate=function(t,e){let i=this.clone();for(let n of i.ops)"close"!==n.type&&(n.to=n.to.translate(t,e)),"curve"===n.type&&(n.cp1=n.cp1.translate(t,e),n.cp2=n.cp2.translate(t,e));return i};var utils$1=Object.freeze({capitalize:capitalize,macroName:macroName,beamsIntersect:beamsIntersect,linesIntersect:linesIntersect,pointOnBeam:pointOnBeam,pointOnLine:pointOnLine,pointOnCurve:pointOnCurve,splitCurve:splitCurve,beamIntersectsX:beamIntersectsX,beamIntersectsY:beamIntersectsY,units:units,lineIntersectsCurve:lineIntersectsCurve,curveIntersectsX:curveIntersectsX,curveIntersectsY:curveIntersectsY,curvesIntersect:curvesIntersect,circlesIntersect:circlesIntersect,beamIntersectsCircle:beamIntersectsCircle,lineIntersectsCircle:lineIntersectsCircle,curveEdge:curveEdge,stretchToScale:stretchToScale,round:round,sampleStyle:sampleStyle,deg2rad:deg2rad});function Snippet(t,e){return this.def=t,this.anchor=e,this.attributes=new Attributes,this}function Hooks(){return{preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]}}function Part(){return this.attributes=new Attributes,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=utils$1,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this.hooks=new Hooks,this}Snippet.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},Snippet.prototype.clone=function(){let t=new Snippet(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t},Part.prototype.macroClosure=function(t){let e=this;return function(t,i){let n=macroName(t);"function"==typeof e[n]?e[n](i):e.debug({type:"warning",label:"🚨 Macro not found",msg:`Macro ${t} is not registered`})}},Part.prototype.debugClosure=function(){let t=this;return function(e){t.debug(e)}},Part.prototype.runHooks=function(t,e=!1){!1===e&&(e=this);let i=this.hooks[t];if(i&&i.length>0)for(let t of i)t.method(e,t.data)},Part.prototype.debug=function(t){this.runHooks("debug",t)},Part.prototype.getId=function(){return this.freeId+=1,""+this.freeId},Part.prototype.unitsClosure=function(t){let e=this;return function(t){return units(t,e.context.settings.units)}},Part.prototype.boundary=function(){if(this.topLeft)return this;let t=new Point(1/0,1/0),e=new Point(-1/0,-1/0);for(let i in this.paths){let n=this.paths[i].boundary();n.render&&(n.topLeft.x<t.x&&(t.x=n.topLeft.x),n.topLeft.y<t.y&&(t.y=n.topLeft.y),n.bottomRight.x>e.x&&(e.x=n.bottomRight.x),n.bottomRight.y>e.y&&(e.y=n.bottomRight.y))}for(let i in this.points){let n=this.points[i],r=n.attributes.get("data-circle");r&&(r=parseFloat(r),n.x-r<t.x&&(t.x=n.x-r),n.y-r<t.y&&(t.y=n.y-r),n.x+r>e.x&&(e.x=n.x+r),n.y+r>e.y&&(e.y=n.y+r))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),e.x===-1/0&&(e.x=0),e.y===-1/0&&(e.y=0);let i=this.context.settings.margin;return this.context.settings.paperless&&i<10&&(i=10),this.topLeft=new Point(t.x-i,t.y-i),this.bottomRight=new Point(e.x+i,e.y+i),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},Part.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform",`translate(${-1*this.topLeft.x}, ${-1*this.topLeft.y})`),this))},Part.prototype.attr=function(t,e,i=!1){return i?this.attributes.set(t,e):this.attributes.add(t,e),this},Part.prototype.inject=function(t){for(let e of["points","paths","snippets"])for(let i in t[e])void 0===this[e][i]&&(this[e][i]=t[e][i].clone());return this},Part.prototype.units=function(t){return units(t,this.context.settings.units)},Part.prototype.shorthand=function(){let t=!!this.context.settings.complete,e=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:utils$1,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:e,debug:this.debugClosure()}};var version="0.31.0";function Svg(t){this.openGroups=[],this.layout={},this.freeId=0,this.body="",this.style="",this.script="",this.defs="",this.pattern=t,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new Attributes,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",t.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",version)}Svg.prototype.runHooks=function(t,e=!1){!1===e&&(e=this);let i=this.hooks[t];if(i.length>0)for(let t of i)t.method(e,t.data)},Svg.prototype.insertText=function(t){if(this.hooks.insertText.length>0)for(let e of this.hooks.insertText)t=e.method(this.pattern.settings.locale,t,e.data);return t},Svg.prototype.debug=function(){},Svg.prototype.render=function(t){this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox",`0 0 ${t.width} ${t.height}`),this.head=this.renderHead(),this.tail=this.renderTail(),this.svg="",this.layout={};for(let e in t.parts){let i=t.parts[e];if(i.render&&t.needs(e)){let t=this.renderPart(i);this.layout[e]={svg:t,transform:i.attributes.getAsArray("transform")},this.svg+=this.openGroup(`${this.idPrefix}part-${e}`,i.attributes),this.svg+=t,this.svg+=this.closeGroup()}}return this.svg=this.prefix+this.renderSvgTag()+this.head+this.svg+this.tail,this.runHooks("postRender"),this.svg},Svg.prototype.renderHead=function(){let t=this.renderStyle();return t+=this.renderScript(),t+=this.renderDefs(),t+=this.openGroup(this.idPrefix+"container")},Svg.prototype.renderTail=function(){let t="";return t+=this.closeGroup(),t+=this.nl()+"</svg>"},Svg.prototype.renderSvgTag=function(){let t="<svg";return this.indent(),t+=this.nl()+this.attributes.render(),this.outdent(),t+=this.nl()+">"+this.nl()},Svg.prototype.renderStyle=function(){let t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},Svg.prototype.renderScript=function(){let t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},Svg.prototype.renderDefs=function(){let t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},Svg.prototype.renderPart=function(t){let e="";for(let i in t.paths){let n=t.paths[i];n.render&&(e+=this.renderPath(n))}for(let i in t.points)t.points[i].attributes.get("data-text")&&(e+=this.renderText(t.points[i])),t.points[i].attributes.get("data-circle")&&(e+=this.renderCircle(t.points[i]));for(let i in t.snippets){let n=t.snippets[i];e+=this.renderSnippet(n,t)}return e},Svg.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),`${this.nl()}<path ${t.attributes.render()} />${this.renderPathText(t)}`},Svg.prototype.renderPathText=function(t){let e=t.attributes.get("data-text");if(!e)return"";this.text=this.insertText(e);let i=t.attributes.renderIfPrefixIs("data-text-"),n="",r=t.attributes.get("data-text-class");r&&r.indexOf("center")>-1?n=' startOffset="50%" ':r&&r.indexOf("right")>-1&&(n=' startOffset="100%" ');let o=this.nl()+"<text>";return this.indent(),o+=`<textPath xlink:href="#${t.attributes.get("id")}" ${n}><tspan ${i}>${this.text}</tspan></textPath>`,this.outdent(),o+=this.nl()+"</text>"},Svg.prototype.renderText=function(t){let e=t.attributes.getAsArray("data-text");if(!1!==e){let t="";for(let i of e)this.text=this.insertText(i),t+=this.text+" ";this.text=this.insertText(t)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);let i=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");let n=`${this.nl()}<text ${t.attributes.renderIfPrefixIs("data-text-")}>`;if(this.indent(),-1!==this.text.indexOf("\n")){let e=this.text.split("\n");n+=`<tspan>${e.shift()}</tspan>`;for(let r of e)n+=`<tspan x="${t.x}" dy="${i}">${r}</tspan>`}else n+=`<tspan>${this.text}</tspan>`;return this.outdent(),n+=this.nl()+"</text>"},Svg.prototype.renderCircle=function(t){return`<circle\n    cx="${t.x}"\n    cy="${t.y}"\n    r="${t.attributes.get("data-circle")}"\n    ${t.attributes.renderIfPrefixIs("data-circle-")}\n  ></circle>`},Svg.prototype.renderSnippet=function(t,e){let i=t.anchor.x,n=t.anchor.y,r=t.attributes.get("data-scale");r&&(t.attributes.add("transform",`translate(${i}, ${n})`),t.attributes.add("transform",`scale(${r})`),t.attributes.add("transform",`translate(${-1*i}, ${-1*n})`));let o=t.attributes.get("data-rotate");o&&t.attributes.add("transform",`rotate(${o}, ${i}, ${n})`);let s=this.nl();return s+=`<use x="${i}" y="${n}" `,s+=`xlink:href="#${t.def}" ${t.attributes.render()}>`,s+="</use>"},Svg.prototype.openGroup=function(t,e=!1){let i=this.nl()+this.nl();return i+=`\x3c!-- Start of group #${t} --\x3e`,i+=this.nl(),i+=`<g id="${t}"`,e&&(i+=` ${e.render()}`),i+=">",this.indent(),this.openGroups.push(t),i},Svg.prototype.closeGroup=function(){return this.outdent(),`${this.nl()}</g>${this.nl()}\x3c!-- end of group #${this.openGroups.pop()} --\x3e`},Svg.prototype.nl=function(){return"\n"+this.tab()},Svg.prototype.tab=function(){let t="";for(let e=0;e<this.tabs;e++)t+="  ";return t},Svg.prototype.indent=function(){this.tabs+=1},Svg.prototype.outdent=function(){this.tabs-=1},Svg.prototype.getId=function(){return this.freeId+=1,""+this.freeId};var GrowingPacker=function(){};GrowingPacker.prototype={fit:function(t){var e,i,n,r,o=t.length,s=o>0?t[0].width:0,h=o>0?t[0].height:0;for(this.root={x:0,y:0,width:s,height:h},e=0;e<o;e++)n=t[e],(i=this.findNode(this.root,n.width,n.height))?(r=this.splitNode(i,n.width,n.height),n.x=r.x,n.y=r.y):(r=this.growNode(n.width,n.height),n.x=r.x,n.y=r.y)},findNode:function(t,e,i){return t.used?this.findNode(t.right,e,i)||this.findNode(t.down,e,i):e<=t.width&&i<=t.height?t:null},splitNode:function(t,e,i){return t.used=!0,t.down={x:t.x,y:t.y+i,width:t.width,height:t.height-i},t.right={x:t.x+e,y:t.y,width:t.width-e,height:i},t},growNode:function(t,e){var i=t<=this.root.width,n=e<=this.root.height,r=n&&this.root.height>=this.root.width+t,o=i&&this.root.width>=this.root.height+e;return r?this.growRight(t,e):o?this.growDown(t,e):n?this.growRight(t,e):i?this.growDown(t,e):null},growRight:function(t,e){var i;return this.root={used:!0,x:0,y:0,width:this.root.width+t,height:this.root.height,down:this.root,right:{x:this.root.width,y:0,width:t,height:this.root.height}},(i=this.findNode(this.root,t,e))?this.splitNode(i,t,e):null},growDown:function(t,e){var i;return this.root={used:!0,x:0,y:0,width:this.root.width,height:this.root.height+e,down:{x:0,y:this.root.height,width:this.root.width,height:e},right:this.root},(i=this.findNode(this.root,t,e))?this.splitNode(i,t,e):null}};var packer_growing=GrowingPacker,binPack=function(t,e){e=e||{};var i=new packer_growing,n=e.inPlace||!1,r=t.map(function(t){return n?t:{width:t.width,height:t.height,item:t}});r=r.sort(function(t,e){return e.width*e.height-t.width*t.height}),i.fit(r);var o={width:r.reduce(function(t,e){return Math.max(t,e.x+e.width)},0),height:r.reduce(function(t,e){return Math.max(t,e.y+e.height)},0)};return n||(o.items=r),o};function Store(){this.data=new Map}function Pattern(t={options:{}}){this.config=t,this.width=0,this.height=0,this.is="",this.store=new Store,this.parts={},this.hooks=new Hooks,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this.Attributes=Attributes,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,layout:!0,options:{}},void 0===this.config.inject&&(this.config.inject=[]),void 0===this.config.dependencies&&(this.config.dependencies={}),void 0===this.config.hide&&(this.config.hide=[]),this.config.resolvedDependencies=this.resolveDependencies(this.config.dependencies),this.config.draftOrder=this.draftOrder(this.config.resolvedDependencies);for(let e in t.options){let i=t.options[e];if("object"==typeof i)if(void 0!==i.pct)this.settings.options[e]=i.pct/100;else if(void 0!==i.mm)this.settings.options[e]=i.mm;else if(void 0!==i.deg)this.settings.options[e]=i.deg;else if(void 0!==i.count)this.settings.options[e]=i.count;else if(void 0!==i.bool)this.settings.options[e]=i.bool;else{if(void 0===i.dflt)throw new Error("Unknown option type: "+JSON.stringify(i));this.settings.options[e]=i.dflt}else this.settings.options[e]=i}this.macros={};const e={parts:this.parts,config:this.config,settings:this.settings,store:this.store,macros:this.macros};this.Part=function(){let t=new Part;t.context=e;for(let i in e.macros)t[macroName(i)]=e.macros[i];return t}}function Design(t,e=!1){const i=function(i){if(Pattern.call(this,t),Array.isArray(e))for(let t of e)this.use(t);else e&&this.use(e);return this.apply(i),this};return(i.prototype=Object.create(Pattern.prototype)).constructor=i,i}Store.prototype.set=function(t,e){this.data.set(t,e)},Store.prototype.setIfUnset=function(t,e){this.data.has(t)||this.data.set(t,e)},Store.prototype.get=function(t){return this.data.get(t)},Pattern.prototype.apply=function(t){if("object"!=typeof t)return this;for(let e of Object.keys(t))if(Array.isArray(t[e]))if(Array.isArray(this.settings[e]))for(let i of t[e])this.settings[e].push(i);else this.settings[e]=t[e];else"object"==typeof t[e]?this.settings[e]=_objectSpread({},this.settings[e],t[e]):this.settings[e]=t[e];return this},Pattern.prototype.runHooks=function(t,e=!1){!1===e&&(e=this);let i=this.hooks[t];if(i.length>0)for(let t of i)t.method(e,t.data)},Pattern.prototype.draft=function(){"sample"!==this.is&&(this.is="draft"),this.runHooks("preDraft");for(let t of this.config.draftOrder)if(this.parts[t]=new this.Part,"string"==typeof this.config.inject[t]&&this.parts[t].inject(this.parts[this.config.inject[t]]),this.needs(t)){let e="draft"+capitalize(t);if("function"!=typeof this[e])throw new Error('Method "'+e+'" on pattern object is not callable');if(this.parts[t]=this[e](this.parts[t]),void 0===this.parts[t])throw new Error("Result of "+e+"() was undefined. Did you forget to return the Part object?");this.parts[t].render=this.wants(t)}return this.runHooks("postDraft"),this},Pattern.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},Pattern.prototype.sampleParts=function(){let t={};this.settings.complete=!1,this.settings.paperless=!1,this.draft();for(let e in this.parts)t[e]=new this.Part,t[e].render=this.parts[e].render;return t},Pattern.prototype.sampleRun=function(t,e,i,n,r=!1){this.draft();for(let o in this.parts){let s=0,h=0;this.parts[o].points.anchor&&(void 0===e[o]?e[o]=this.parts[o].points.anchor:e[o].sitsOn(this.parts[o].points.anchor)||(s=this.parts[o].points.anchor.dx(e[o]),h=this.parts[o].points.anchor.dy(e[o])));for(let e in this.parts[o].paths)t[o].paths[e+"_"+i]=this.parts[o].paths[e].clone().attr("style",sampleStyle(i,n)),this.parts[o].points.anchor&&(t[o].paths[e+"_"+i]=t[o].paths[e+"_"+i].translate(s,h)),!1!==r&&t[o].paths[e+"_"+i].attributes.add("class",r)}},Pattern.prototype.sampleOption=function(t){let e,i;this.is="sample",this.runHooks("preSample");let n=1,r={},o=this.sampleParts(),s=this.config.options[t];if("object"==typeof s.list)return this.sampleListOption(t);if(void 0===s.min||void 0===s.max){s={min:.9*s,max:1.1*s}}void 0!==s.pct&&(n=100),i=s.min/n,e=(s.max/n-i)/9;for(let n=1;n<11;n++)this.settings.options[t]=i,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling option ${t} with value ${round(i)}`}),this.sampleRun(o,r,n,10),i+=e;return this.parts=o,this.runHooks("postSample"),this},Pattern.prototype.sampleListOption=function(t){let e=this.sampleParts(),i=this.config.options[t],n={},r=1,o=i.list.length;for(let s of i.list)this.settings.options[t]=s,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling option ${t} with value ${round(s)}`}),this.sampleRun(e,n,r,o),r++;return this.parts=e,this},Pattern.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");let e={},i=this.sampleParts(),n=this.settings.measurements[t];if(void 0===n)throw new Error("Cannot sample a measurement that is undefined: "+t);let r=n/50;n*=.9;for(let o=1;o<11;o++)this.settings.measurements[t]=n,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling option ${t} with value ${round(n)}`}),this.sampleRun(i,e,o,10),n+=r;return this.parts=i,this.runHooks("postSample"),this},Pattern.prototype.sampleModels=function(t,e=!1){this.is="sample",this.runHooks("preSample");let i={},n=this.sampleParts(),r=0,o=Object.keys(t).length;for(let s in t){r++,this.settings.measurements=t[s],this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:`Sampling model ${s}`});let h=s===e?"sample-focus":"";this.sampleRun(n,i,r,o,h)}return this.parts=n,this.runHooks("postSample"),this},Pattern.prototype.debug=function(t){this.runHooks("debug",t)},Pattern.prototype.render=function(){return this.svg=new Svg(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},Pattern.prototype.on=function(t,e,i){this.hooks[t].push({method:e,data:i})},Pattern.prototype.use=function(t,e=!1){return this.debug({type:"success",label:"🔌 Plugin loaded",msg:`${t.name} v${t.version}`}),t.hooks&&this.loadPluginHooks(t,e),t.macros&&this.loadPluginMacros(t),this},Pattern.prototype.loadPluginHooks=function(t,e){for(let i of Object.keys(this.hooks))if("function"==typeof t.hooks[i])this.on(i,t.hooks[i],e);else if(Array.isArray(t.hooks[i]))for(let n of t.hooks[i])this.on(i,n,e)},Pattern.prototype.loadPluginMacros=function(t){for(let e in t.macros)"function"==typeof t.macros[e]&&this.macro(e,t.macros[e])},Pattern.prototype.macro=function(t,e){this.macros[t]=e},Pattern.prototype.pack=function(){let t=[];for(let e in this.parts){let i=this.parts[e];if(i.attributes.remove("transform"),i.render&&this.needs(e)){i.stack();let n=i.bottomRight.x-i.topLeft.x,r=i.bottomRight.y-i.topLeft.y;!0===this.settings.layout?t.push({id:e,width:n,height:r}):(this.width<n&&(this.width=n),this.height<r&&(this.height=r))}}if(!0===this.settings.layout){let e=binPack(t,{inPlace:!0});for(let e of t){let t=this.parts[e.id];0===e.x&&0===e.y||t.attr("transform",`translate (${e.x}, ${e.y})`)}this.width=e.width,this.height=e.height}else if("object"==typeof this.settings.layout){this.width=this.settings.layout.width,this.height=this.settings.layout.height;for(let t of Object.keys(this.settings.layout.parts)){let e=this.settings.layout.parts[t];"object"==typeof e.move&&this.parts[t].attributes.set("transform","translate("+e.move.x+", "+e.move.y+")");let i=this.parts[t].topLeft.shiftFractionTowards(this.parts[t].bottomRight,.5),n={x:0,y:0};if(e.flipX){let e=n.x-i.x,r=`translate(${-1*i.x}, ${-1*i.y})`;r+=" scale(-1, 1)",r+=` translate(${-1*i.x+2*e}, ${i.y})`,this.parts[t].attributes.add("transform",r)}if(e.flipY){let e=n.y-i.y,r=`translate(${-1*i.x}, ${-1*i.y})`;r+=" scale(1, -1)",r+=` translate(${i.x}, ${-1*i.y+2*e})`,this.parts[t].attributes.add("transform",r)}if(e.rotate){let r=`rotate(${e.rotate}, ${i.x-n.x}, ${i.y-n.y})`;this.parts[t].attributes.add("transform",r)}}}return this},Pattern.prototype.draftOrder=function(t=this.resolveDependencies()){let e=[],i={};return Object.keys(t).forEach(function n(r,o){Array.isArray(o)||(o=[]),o.push(r),i[r]=!0,void 0!==t[r]&&t[r].forEach(function(t){i[t]||n(t,o.slice(0))}),e.indexOf(r)<0&&e.push(r)}),e},Pattern.prototype.resolveDependency=function(t,e,i=this.config.dependencies,n=[]){if(void 0===t[e]&&(t[e]=!0),"string"==typeof i[e])return n.push(i[e]),this.resolveDependency(t,i[e],i,n);if(Array.isArray(i[e])){if(0===i[e].length)return[];0===n.length&&(n=i[e]);for(let r of i[e])n.concat(this.resolveDependency(t,r,i,n))}return n},Pattern.prototype.resolveDependencies=function(t=this.config.dependencies){if(Array.isArray(this.config.parts))for(let t of this.config.parts)void 0===this.config.dependencies[t]&&(this.config.dependencies[t]=[]);let e={},i={};for(let n of Object.keys(t))e[n]=this.resolveDependency(i,n,t);for(let t of Object.keys(i))void 0===e[t]&&(e[t]=[]);return e},Pattern.prototype.needs=function(t){if(void 0===this.settings.only||!1===this.settings.only)return!0;if("string"==typeof this.settings.only){if(this.settings.only===t)return!0;if(Array.isArray(this.config.resolvedDependencies[this.settings.only]))for(let e of this.config.resolvedDependencies[this.settings.only])if(e===t)return!0}else if(Array.isArray(this.settings.only))for(let e of this.settings.only){if(e===t)return!0;for(let i of this.config.resolvedDependencies[e])if(i===t)return!0}return!1},Pattern.prototype.isHidden=function(t){return!(!Array.isArray(this.config.hide)||-1===this.config.hide.indexOf(t))},Pattern.prototype.wants=function(t){if(void 0===this.settings.only||!1===this.settings.only){if(this.isHidden(t))return!1}else{if("string"==typeof this.settings.only)return this.settings.only===t;if(Array.isArray(this.settings.only)){for(let e of this.settings.only)if(e===t)return!0;return!1}}return!0};var index={version:version,Design:Design,Pattern:Pattern,Point:Point,Path:Path,Snippet:Snippet,utils:utils$1,patterns:{},plugins:{}};export default index;
//# sourceMappingURL=index.mjs.map
